// CPPCommon.h: common include files used by CPPParser

#ifndef INCL_CPP_COMMON_H
#define INCL_CPP_COMMON_H

// define bool if your compiler does not support it and your STL does not define it.
//    typedef int bool
//    #define true 1
//    #define false 0

#include "tokens.h"
#include "JLStr.h"
#include "MyZZPred.h"
#include "AToken.h"
#include "ATokPtr.h"
#include "FastToken.h"
#include "JLRefPtr.h"
#include "CPPConst.h"
#include "CPPScopeState.h"
#include "CPPScopeLevel.h"

// Incomplete declarations of classes -- we can hand pointers and
// smart-pointers to these around in the grammar, but we try not 
// to use the complete types.
#include "CPPExprIncomplete.h"
#include "CPPTypeIncomplete.h"
#include "CPPDeclIncomplete.h"
#include "CPPScopeIncomplete.h"
#include "TemplateParameterListIncomplete.h"
#include "TemplateArgumentListIncomplete.h"
#include "TokenListIncomplete.h"
#include "StrListIncomplete.h"

#endif
