// CPPDeclObject.cpp: Implementation of Object-declaration class.

#include "CPPDecl.h"

////////////////////////////////////////////////////////////////////
// SameDecl: Is the declaration identicial to another declaration?
// Inputs: none
// Outputs: none
// Return: 
//    bool    true if the declarations are identical, meaning
//            that the types and modifiers are identical.
////////////////////////////////////////////////////////////////////
// virtual
bool 
CPPDeclObject::SameDecl(
   const CPPDecl& rhs
) const 
{
   assertValid(); 

   // Note that we can just compare the declType pointers, because
   // we are guaranteed that there is only one pointer to a unique type.
   return 
      CPPDecl::SameDecl(rhs) &&
      GetType() == rhs.GetType() &&
      GetStorageClass() == rhs.GetStorageClass() &&
      GetDeclModifier() == rhs.GetDeclModifier();
}

