// CPPParserSymOption.cpp: option management for the preprocessor

#include "CPPParserSym.h"
#include <set>

class CPPParserSym::OptionSet :
   public VRefCount,
   public set<CPPParser::Option, less<CPPParser::Option>, allocator<CPPParser::Option> >
{};

///////////////////////////////////////////////////////////////////////
void 
CPPParserSym::SetOption(
   Option opt, 
   bool value
)
{
   if (value)
   {
      options->insert(opt);
   } else {
      options->erase(opt);
   }
}


///////////////////////////////////////////////////////////////////////
bool 
CPPParserSym::GetOption(
   Option opt
) const
{
   return options->find(opt) != options->end();
}

///////////////////////////////////////////////////////////////////////
// Static method to create the option set.  Used so that the parser
// class need not define the option set object everywhere.
///////////////////////////////////////////////////////////////////////
//static
CPPParserSym::OptionSetRefI
CPPParserSym::NewOptionSet()
{
   return new OptionSet;
}
