// CPPSymTablePacking.cpp: methods to manage the symbol table packing stack

#include "CPPSymTable.h"
#include <stack>
#include <deque>

class CPPSymTable::PackingStack : 
   public VRefCount,
   public stack<int, deque<int, allocator<int> > >
{};

CPPSymTable::PackingStackRefI
CPPSymTable::NewPackingStack()
{
   return new PackingStack;
}

void 
CPPSymTable::SetDefaultPacking()
{
   SetPacking(DefaultPacking);
}

void 
CPPSymTable::SetPacking(int packing)
{
   PopPacking();
   PushPacking(packing);
}

void 
CPPSymTable::PopPacking()
{
   packingStack->pop();
}

void 
CPPSymTable::PushPacking(int packing)
{
   packingStack->push(packing);
}

int 
CPPSymTable::GetPackingStackSize() const
{
   return packingStack->size();
}

int
CPPSymTable::GetCurrentPacking() const
{
   return packingStack->top();
}
