// CPPTypeClassBaseClass.h: Definition of CPPTypeClass base class specifiers

#ifndef INCL_CPPTYPECLASSBASECLASS_H
#define INCL_CPPTYPECLASSBASECLASS_H

#include "CPPTypeIncomplete.h"
#include "CPPTypeClass.h"
#include "CPPConst.h"
#include "JL_DList.h"

// Representation of base classes
class CPPTypeClass::BaseClassSpecifier {
   public:
      BaseClassSpecifier() {}
      BaseClassSpecifier(
         CPPTypeRefI baseClass_,
         CPPConst::BaseSpecifier baseSpecifier_
      ) : 
         baseClass(baseClass_), 
         baseSpecifier(baseSpecifier_)
      {
      }

      // accessor methods
      CPPTypeRefI GetBaseClass() const { return baseClass; }
      CPPConst::BaseSpecifier GetBaseSpecifier() const { return baseSpecifier; }
   private:
      CPPTypeRefI baseClass;
      CPPConst::BaseSpecifier baseSpecifier;
};

class CPPTypeClass::BaseClassList : 
   public VRefCount, 
   public JL_DList<
      CPPTypeClass::BaseClassSpecifier, 
      allocator<CPPTypeClass::BaseClassSpecifier>
   >
{
};

#endif
