// CPPTypeContainers.h: Definitions of CPPType containers

#ifndef INCL_CPPTYPECONTAINERS_H
#define INCL_CPPTYPECONTAINERS_H

#include "CPPTypeIncomplete.h"
#include "JL_DList.h"
#include <map>
#include <set>

// Make MSVC++ 4.2 shut up about truncated names
#pragma warning (disable:4786)

// Comparator for pointers to types
struct CPPTypePtrComparator {
   bool operator ()(CPPType* lhs, CPPType* rhs) const
   {
      return lhs->LessThanNode(*rhs);
   }
};

// Set of dumb pointers to derived types
typedef set<CPPType*, CPPTypePtrComparator, allocator<CPPType*> > RawCPPTypePtrSet;
class CPPTypePtrSet : public VRefCount, public RawCPPTypePtrSet
{
};

// Map from builtin type specifiers to CPPType
typedef map<
   CPPConst::TypeSpecifier, 
   CPPTypeRefI,
   less<CPPConst::TypeSpecifier>, 
   allocator<CPPTypeRefI>
> RawCPPBuiltinTypeTable;

class CPPBuiltinTypeTable : public VRefCount, public RawCPPBuiltinTypeTable
{
};

#endif
