// CPPTypeEnum.cpp: Implementation of enumeration type class.

#include "CPPType.h"
#include "CPPTypeEnum.h"

/////////////////////////////////////////////////////////////////
// FormatName: Format the name of the type, using the names of the
// modified types where needed to construct the full type name.
//
// Inputs:
//    const JLStr&  declName   If non-empty, then this is used
//                              to format the declarator name
//                              in the proper position.
//    const JLStr&  suffixStr  Any accumulated suffix string
// Return:
//    JLStr    The formatted type name
/////////////////////////////////////////////////////////////////
// virtual 
JLStr 
CPPTypeEnum::FormatName(
   const JLStr& declName,
   const JLStr& suffixStr,
   StrListRefI,
   bool
) const
{
   assertValid();
   return "enum " + name + " " + declName + suffixStr;
}
