// TemplateArgument.cpp: Implementation for TemplateArgument classes

#include "TemplateArgumentList.h"
#include "CPPType.h"
#include "CPPExpr.h"

//virtual
JLStr
TemplateArgumentType::Format()
const
{
   return GetType()->FormatName("", "", StrListRefI(), true);
}

//virtual
JLStr
TemplateArgumentValue::Format()
const
{
   // Try to evaluate the argument
   double tmpDouble;
   bool isInteger;
   if (value->EvaluateConstant(tmpDouble, isInteger))
   {
      if (isInteger)
      {
         char buf[100];
         sprintf(buf, "%d", (int)tmpDouble);
         return buf;
      } else {
         // Error -- could not evaluate expression
         // TODO: figure out how to report this error
         return "error";
      }
   } else if (value->IsPlaceholder())
   {
      return value->Format();
   } else {
      // TODO: figure out what to do with expressions that don't evaluate to
      // constants but are still constant-expressions like function addresses, etc.
      return "error";
   }
}
