// TemplateParameterList.cpp: implemenation of template parameter classes

#include "TemplateParameterList.h"
#include "CPPType.h"
#include "TokenList.h"
#include "CPPExpr.h"

TemplateParameter::TemplateParameter(
   const JLStr& name_,
   TokenListRefI defaultParameterTokens_
) :
   name(name_)
{
   defaultParameterTokens = new TokenList(*defaultParameterTokens_);
}

TemplateParameter::~TemplateParameter()
{
}

TemplateParameterType::TemplateParameterType(
   const JLStr& name_,
   TokenListRefI defaultParameterTokens_,
   CPPTypeRefI placeholderType_
) :
   TemplateParameter(name_, defaultParameterTokens_),
   placeholderType(placeholderType_)
{}


//virtual 
JLStr 
TemplateParameterType::Format() 
const
{
   return placeholderType->FormatName("", "", StrListRefI(), true);
}


//virtual 
JLStr 
TemplateParameterValue::Format() 
const
{
   return placeholderValue->Format();
}

