// BufferedCPreParser.h:  Subclass of CPreParserImp that supports output
// of tokens to a specialized token buffer

#ifndef INCL_BUFFEREDCPREPARSER_H
#define INCL_BUFFEREDCPREPARSER_H

#include "..\cpre\tokens.h"
#include "..\cpre\CPreParserImp.h"

class CPreToCPPBuffer;
class ANTLRTokenStream;

class BufferedCPreParser : public CPreParserImp
{
public:
   BufferedCPreParser(
      ANTLRTokenStream *cPreInput,
      CPreToCPPBuffer* buffer_ = 0
   );
   virtual ~BufferedCPreParser() {}

   // Set the output buffer
   void SetBuffer(CPreToCPPBuffer* buffer_) { buffer = buffer_; }

   // Overide token output methods
   virtual void ExpandAndOutputTokenList(TokenList *list);
   virtual void OutputToken(const ANTLRTokenPtr& token) const;
private:
   CPreToCPPBuffer* buffer;
};

#endif
