// cpre_tokenstream.cpp: Connection of expression token list to 
// expression parser.

#include "Tokenstream.h"
#include "FastToken.h"

////////////////////////////////////////////////////////////////////////
// ctor: Copies the input list, but this is an infrequent operation.
TokenListStream::TokenListStream(
   const TokenList& tokenList_
) :
   tokenList(tokenList_),
   iter(tokenList.begin())
{
}

////////////////////////////////////////////////////////////////////////
// getToken:: Return the next token in the list.  When the end of the
// list is reached, create new TOK_Eof tokens and return them instead.
// The caller is responsible for deleting the token iff the refcount
// drops to zero.
ANTLRTokenPtr 
TokenListStream::getToken()
{
   ANTLRTokenPtr retval;
   if (iter != tokenList.end())
   {
      retval = *iter++;
   } else {
      retval = FastToken::newToken(TOK_Eof, "", 0);
   }
   return retval;
}

