// cpre_tokenstream.h:  Tokenlist-based input stream object.  Used for
// re-parsing lists of tokens during preprocessor expression evaluation.

#ifndef INCL_CPRE_TOKENSTREAM_H
#define INCL_CPRE_TOKENSTREAM_H

#include "tokens.h"
#include "AToken.h"
#include "ATokPtr.h"
#include "ATokenStream.h"
#include "tokenList.h"


///////////////////////////////////////////////////////////////////////
//                    connection to expression parser                //
///////////////////////////////////////////////////////////////////////
class TokenListStream : public ANTLRTokenStream 
{
public:
   // Note: token list arg must remain valid during life of this object!
   TokenListStream(const TokenList& tokenList_);

   // Method to get next token from list
   virtual ANTLRTokenPtr getToken();

private:
   TokenList tokenList;
   TokenList::iterator iter;
};

#endif
