#ifndef INCL_TOKENKEY_H
#define INCL_TOKENKEY_H

#include <JL_DList.h>
#include "tokens.h"
#include "AToken.h"
#include "ATokPtr.h"
#include <string.h>

///////////////////////////////////////////////////////////////////////
// ANTLRTokenPtr subclass that supports "value" equality operator
// that compares the text of two tokens.  This class is designed to
// be used as the key of a has table.
///////////////////////////////////////////////////////////////////////
class ANTLRTokenKey : public ANTLRTokenPtr
{
public:
   ANTLRTokenKey() {}
   ANTLRTokenKey(const ANTLRTokenPtr& tokPtr_) : ANTLRTokenPtr(tokPtr_) {}
   ANTLRTokenKey(const _ANTLRTokenPtr tokPtr_) : ANTLRTokenPtr(tokPtr_) {}

   bool operator == (const ANTLRTokenPtr& rhs) const
   { 
      return (
         (strcmp((*this)->getText(), rhs->getText()) == 0)
      );
   }
   bool operator != (const ANTLRTokenPtr& rhs) const { return !operator==(rhs); }

   // Must make operator= explicit, it is not inherited
   void operator = (const ANTLRTokenPtr& rhs) { ANTLRTokenPtr::operator=(rhs); }
   void operator = (ANTLRAbstractToken *addr) { ANTLRTokenPtr::operator=(addr); }
};

#endif

