// cpre_debug.cpp: Debugging and diagnostic methods

#include "CPreParserImp.h"
#include "tokenList.h"

///////////////////////////////////////////////////////////////////////
void 
CPreParserImp::DumpTokenList(
   const TokenList *tokenList
) const
{
   // cast away const, we promise not to change the list
   for (
      TokenList::const_iterator iter(tokenList->begin());
      iter != tokenList->end();
      iter++
   )
   {
      printf("%s ", (*iter)->getText());
   }
}

///////////////////////////////////////////////////////////////////////
void 
CPreParserImp::panic(char *err)
{
   fprintf(stderr, "CPreParser: %s\n", err);
   exit(-1);
}

