/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */
#include <stdio.h>
#define ANTLR_VERSION	133
#include "tokens.h"

#include "FastToken.h"
#include "ATokPtr.h"
//typedef FastToken ANTLRToken;

#ifdef _MSC_VER
// MSVC++ doesn't grok bool, so include an STL header since they define
// bool and we'd like the same bool defined everywhere.  This works
// for both Rogue Wave and MSVC++ STL.
#include <new>
#endif

#include "cpre_expr_support.h"
#include "AParser.h"
#include "CPreExpr.h"
#include "DLexerBase.h"
#include "ATokPtr.h"
#ifndef PURIFY
#define PURIFY(r,s)
#endif

  CPreValue   
CPreExpr::constant_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "constant_expression");
	int _success = 0;
	  _retv   = logical_or_expression();

	{
		int _success = 0;
		if ((LA(1)==TOK_QUESTIONMARK) ) {
			_match(TOK_QUESTIONMARK);
						consume();
			  CPreValue operand1   = logical_or_expression();

			_match(TOK_COLON);
						consume();
			  CPreValue operand2   = logical_or_expression();

			
			bool condition = (_retv.IsInteger() ? ((long)_retv != 0) : ((double)_retv != 0.0));
			_retv = condition ? operand1 : operand2;
			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::logical_or_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "logical_or_expression");
	int _success = 0;
	  _retv   = logical_and_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_OR)))
				break;
			int _success = 0;
			_match(TOK_OR);
						consume();
			  CPreValue operand   = logical_and_expression();

			
			// Logical TOK_OR must use integers
			_retv = CPreValue( (long)((long)_retv || (long)operand) );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::logical_and_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "logical_and_expression");
	int _success = 0;
	  _retv   = inclusive_or_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AND)))
				break;
			int _success = 0;
			_match(TOK_AND);
						consume();
			  CPreValue operand   = inclusive_or_expression();

			
			// Logical TOK_AND must use integers
			_retv = CPreValue( (long)((long)_retv && (long)operand) );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::inclusive_or_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "inclusive_or_expression");
	int _success = 0;
	  _retv   = exclusive_or_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_BITWISEOR)))
				break;
			int _success = 0;
			_match(TOK_BITWISEOR);
						consume();
			  CPreValue operand   = exclusive_or_expression();

			
			// Bitwise TOK_OR must use integers -- invalid for doubles, but try anyway
			_retv = CPreValue( (long)_retv | (long)operand );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::exclusive_or_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "exclusive_or_expression");
	int _success = 0;
	  _retv   = and_expression();

	{
		while ( 1 ) {
			if ( !((
			LA(1)==TOK_BITWISEXOR)))
				break;
			int _success = 0;
			_match(TOK_BITWISEXOR);
						consume();
			  CPreValue operand   = and_expression();

			
			// Bitwise XOR must use integers -- invalid for doubles, but try anyway
			_retv = CPreValue( (long)_retv ^ (long)operand );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::and_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "and_expression");
	int _success = 0;
	  _retv   = equality_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND)))
				break;
			int _success = 0;
			_match(TOK_AMPERSAND);
						consume();
			  CPreValue operand   = equality_expression();

			
			// Bitwise TOK_AND must use integers -- invalid for doubles, but try anyway
			_retv = CPreValue( (long)_retv & (long)operand );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::equality_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr eo=NULL;
	Tracer tracer(this, "equality_expression");
	int _success = 0;
	  _retv   = relational_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_EQUAL || LA(1)==TOK_NOTEQUAL)))
				break;
			int _success = 0;
			_setmatch(EQUALITY_OPERATOR_set);
			
			eo = (ANTLRTokenPtr)LT(1);
			consume();
			  CPreValue operand   = relational_expression();

			
			switch ( eo->getType())
			{
				case TOK_NOTEQUAL:
				// Integers promoted to double can be compared with the same result
				_retv = CPreValue( (long)((double)_retv != (double)operand) );
				break;
				case TOK_EQUAL:
				// Integers promoted to double can be compared with the same result
				_retv = CPreValue( (long)((double)_retv == (double)operand) );
				break;
			}
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::relational_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr ro=NULL;
	Tracer tracer(this, "relational_expression");
	int _success = 0;
	  _retv   = shift_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_GREATERTHAN || 
			LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO)))
				break;
			int _success = 0;
			_setmatch(RELATIONAL_OPERATOR_set);
			
			ro = (ANTLRTokenPtr)LT(1);
			consume();
			  CPreValue operand   = shift_expression();

			
			switch ( ro->getType())
			{
				case TOK_LESSTHAN:
				_retv = CPreValue( (long)((double)_retv < (double)operand) );
				break;
				case TOK_GREATERTHAN:
				_retv = CPreValue( (long)((double)_retv > (double)operand) );
				break;
				case TOK_LESSTHANOREQUALTO:
				_retv = CPreValue( (long)((double)_retv <= (double)operand) );
				break;
				case TOK_GREATERTHANOREQUALTO:
				_retv = CPreValue( (long)((double)_retv >= (double)operand) );
				break;
			}
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::shift_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr so=NULL;
	Tracer tracer(this, "shift_expression");
	int _success = 0;
	  _retv   = additive_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTRIGHT)))
				break;
			int _success = 0;
			_setmatch(SHIFT_OPERATOR_set);
			
			so = (ANTLRTokenPtr)LT(1);
			consume();
			  CPreValue operand   = additive_expression();

			
			// Slow, but shift in #if expression is rare
			long shiftamount = (long)operand;
			long value = (long)_retv;
			if ( so->getType() == TOK_SHIFTRIGHT)
			{
				shiftamount = -shiftamount;
			}
			if (shiftamount < -64) shiftamount = -64;
			if (shiftamount > 64) shiftamount = 64;
			while (shiftamount > 0)
			{
				value *= 2;
				shiftamount--;
			}
			while (shiftamount < 0)
			{
				value /= 2;
				shiftamount++;
			}
			_retv = CPreValue(value);
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::additive_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr ao=NULL;
	Tracer tracer(this, "additive_expression");
	int _success = 0;
	  _retv   = multiplicative_expression();

	{
		while ( 1 ) {
			if ( !((
			LA(1)==TOK_MINUS || LA(1)==TOK_PLUS)))
				break;
			int _success = 0;
			_setmatch(ADDITIVE_OPERATOR_set);
			
			ao = (ANTLRTokenPtr)LT(1);
			consume();
			  CPreValue operand   = multiplicative_expression();

			
			switch ( ao->getType())
			{
				case TOK_PLUS:
				if (!_retv.IsInteger() || !operand.IsInteger())
				{
					_retv = CPreValue((double)_retv + (double)operand);
				} else {
					_retv = CPreValue((long)_retv + (long)operand);
				}
				break;
				case TOK_MINUS:
				if (!_retv.IsInteger() || !operand.IsInteger())
				{
					_retv = CPreValue((double)_retv - (double)operand);
				} else {
					_retv = CPreValue((long)_retv - (long)operand);
				}
				break;
			}
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::multiplicative_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr mo=NULL;
	Tracer tracer(this, "multiplicative_expression");
	int _success = 0;
	  _retv   = unary_expression();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_DIVIDE || LA(1)==TOK_MOD || LA(1)==TOK_STAR)))
				break;
			int _success = 0;
			_setmatch(MULTIPLICATIVE_OPERATOR_set);
			
			mo = (ANTLRTokenPtr)LT(1);
			consume();
			  CPreValue operand   = unary_expression();

			
			switch ( mo->getType())
			{
				case TOK_STAR:
				if (!_retv.IsInteger() || !operand.IsInteger())
				{
					return CPreValue((double)_retv * (double)operand);
				} else {
					return CPreValue((long)_retv * (long)operand);
				}
				break;
				case TOK_DIVIDE:
				if (!_retv.IsInteger() || !operand.IsInteger())
				{
					return CPreValue((double)_retv + ((double)operand == 0.0 ? 1.0 : (double)operand));
				} else {
					long operandval = (long)operand;
					if (operandval==0) operandval = 1;
					return CPreValue((long)_retv / operandval);
				}
				break;
				case TOK_MOD:
				{
					// Mod only makes sense for integers
					long operandval = (long)operand;
					if (operandval==0) operandval = 1;
					return CPreValue((long)_retv % operandval);
				}
				break;
			}
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPreValue   
CPreExpr::unary_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr uo=NULL;
	Tracer tracer(this, "unary_expression");
	int _success = 0;
	if ((LA(1)==TOK_LPAREN || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || 
	LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_CHARACTER) ) {
		  _retv   = primary_expression();

		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_MINUS || LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_TILDE) ) {
		_setmatch(UNARY_OPERATOR_set);
		
		uo = (ANTLRTokenPtr)LT(1);
		consume();
		  CPreValue operand   = unary_expression();

		
		switch ( uo->getType())
		{
			case TOK_PLUS:
			_retv = operand;
			break;
			case TOK_MINUS:
			if (operand.IsInteger())
			{
				_retv = CPreValue(-(long)operand);
			} else {
				_retv = CPreValue(-(double)operand);
			}
			break;
			case TOK_TILDE:
			// ~ cannot apply to double value, but process doubles as longs anyway
			_retv = CPreValue(~(long)operand);
			break;
			case TOK_NOT:
			_retv = CPreValue((long)!(long)operand);
			break;
		}
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err7);
	}
	return _retv;
}

  CPreValue   
CPreExpr::primary_expression(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	Tracer tracer(this, "primary_expression");
	int _success = 0;
	if ((LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || 
	LA(1)==TOK_FLOATTWO || LA(1)==TOK_CHARACTER) ) {
		  _retv   = constant();

		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_LPAREN) ) {
		_match(TOK_LPAREN);
				consume();
		  _retv   = constant_expression();

		_match(TOK_RPAREN);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err8);
	}
	return _retv;
}

  CPreValue   
CPreExpr::constant(void)
{
	  CPreValue   	 _retv;
	zzRULE;
	ANTLRTokenPtr oct=NULL, dec=NULL, hex=NULL, chr=NULL, fl1=NULL, fl2=NULL;
	Tracer tracer(this, "constant");
	int _success = 0;
	if ((LA(1)==TOK_OCTALINT) ) {
		_match(TOK_OCTALINT);
		
		oct = (ANTLRTokenPtr)LT(1);

		_retv = ConvertOctal( oct);   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_DECIMALINT) ) {
		_match(TOK_DECIMALINT);
		
		dec = (ANTLRTokenPtr)LT(1);

		_retv = ConvertDecimal( dec);   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_HEXADECIMALINT) ) {
		_match(TOK_HEXADECIMALINT);
		
		hex = (ANTLRTokenPtr)LT(1);

		_retv = ConvertHexadecimal( hex);   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_CHARACTER) ) {
		_match(TOK_CHARACTER);
		
		chr = (ANTLRTokenPtr)LT(1);

		_retv = ConvertCharacter( chr);   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_FLOATONE) ) {
		_match(TOK_FLOATONE);
		
		fl1 = (ANTLRTokenPtr)LT(1);

		_retv = ConvertFloat( fl1);   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_FLOATTWO) ) {
		_match(TOK_FLOATTWO);
		
		fl2 = (ANTLRTokenPtr)LT(1);

		_retv = ConvertFloat( fl2);   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err9);
	}
	return _retv;
}
