// cpre_expr_support.h:  Auxilliary classes for the C preprocessor expression
// evaluator parser.

#ifndef INCL_CPRE_EXPR_SUPPORT_H
#define INCL_CPRE_EXPR_SUPPORT_H

///////////////////////////////////////////////////////////////////////
//                    Expression evaluator classes                   //
///////////////////////////////////////////////////////////////////////

class CPreValue 
{
public: 
   enum ValueType { Integer, Float };

   CPreValue(long val=0) : type(Integer) { v.l = val; }
   CPreValue(double val) : type(Float) { v.d = val; }

   operator double () const { return type==Integer ? (double)v.l : v.d; }
   operator long ()  const { return type==Integer ? v.l : (long)v.d; }

   ValueType GetType() const { return type; }
   bool IsInteger() const { return type == Integer; }

private:
   ValueType type;
   union {
      double d;
      long l;
   } v;
};

#endif
