// cpre_pragma.cpp: pragma processing

#include "CPreParserImp.h"

//////////////////////////////////////////////////////////////
// HandlePragma: Process a pragma line.
// Inputs: none, but implicitly uses tempTokenList.
// Outputs: none
// Return: none
//////////////////////////////////////////////////////////////
// virtual
void
CPreParserImp::HandlePragma()
{
   // Create an end-of-pragma token
   AppendToTokenList(
      tempTokenList, 
      FastToken::newToken(TOK_PRAGMA_END, "", (*tempTokenList->begin())->getLine())
   );

   // Output the pragma line
   if (GetOption(OptExpandPragmas))
   {
      ExpandAndOutputTokenList(tempTokenList);
   } else {
      OutputTokenList(tempTokenList);
   }
}
