// cpre_stringstream.h: Alternate lexer input stream from string

#ifndef INCL_CPRE_STRINGSTREAM_H
#define INCL_CPRE_STRINGSTREAM_H

#include "JLStr.h"
#include "DLexerBase.h"

///////////////////////////////////////////////////////////////////////
// Used for rescanning tokens that have been created with ## operator
class CPreStringInput : public DLGInputStream {
public:
   CPreStringInput(const JLStr& s) :
      input(s),
      pos(0)
    {}

   virtual int nextChar()
   {
      return (pos < (int)input.length() ? input[(size_t)pos++] : EOF);
   }
private:
   JLStr input;
   int pos;
};


#endif

