// TokenList.cpp: TokenList implementation

#include "tokenList.h"

// Changed to equals() method instead of operator == 
// because STL list<> overrides with global template
// See global operator==(list<>, list<>)

// This is specialized because we only want to compare parts of
// the tokens in the list.
bool 
TokenList::equals(
   const TokenList& rhs
) const
{
   if (size() != rhs.size())
   {
      return false;
   }

   TokenList::const_iterator iterThis(begin());
   TokenList::const_iterator iterRhs(rhs.begin());

   while (iterThis != end())
   {
      if (
         (*iterThis)->getType() != (*iterRhs)->getType() ||
         strcmp((*iterThis)->getText(), (*iterRhs)->getText()) != 0
      )
      {
         return false;
      }
      iterThis++;
      iterRhs++;
   }
   return true;
}

