#ifndef INCL_TOKENLIST_H
#define INCL_TOKENLIST_H

#pragma warning (disable:4786)    // long debug names

#include <JL_DList.h>
#include "tokens.h"
#include "AToken.h"
#include "ATokPtr.h"
#include "TokenListIncomplete.h"

///////////////////////////////////////////////////////////////////////
//                     Token lists                                   //
///////////////////////////////////////////////////////////////////////

// Generic token list support class with ref counting
// Does not need any implementation other than that provided by base classes.
typedef JL_DList<ANTLRTokenPtr, allocator<ANTLRTokenPtr> > RawTokenList;

class TokenList : public VRefCount, public RawTokenList
{
public:
   // Content equality test (cannot use == with STL list<> inheritance)
   bool equals(const TokenList& rhs) const;
};

#endif

