// DeclareIncomplete.h:  Define macros to declare an incomplete
// type, and its associated ref-counted pointers
//
// The macro DECLARE_INCOMPLETE(T) will declare the following types:
//   T               : the incomplete type "class T"
//   refcnt_ptr<T>   : an incomplete type for refcounted ptr-to-T
//   refcnt_cptr<T>  : an incomplete type for refcounted const-ptr-to-T
//   refcnt_ptrI<T>  : a complete type for refcounted ptr-to-incomplete-T
//   refcnt_cptrI<T> : a complete type for refcounted const-ptr-to-incomplete-T

#ifndef INCL_DECLAREINCOMPLETE_H
#define INCL_DECLAREINCOMPLETE_H

#include "STLIncomplete.h"
#include "JLRefPtr.h"

#define DECLARE_INCOMPLETE(T) \
   class T; \
   typedef refcnt_ptr<T> T##Ref; \
   typedef refcnt_cptr<T> T##CRef; \
   typedef refcnt_ptrI<T> T##RefI; \
   typedef refcnt_cptrI<T> T##CRefI;

#endif

