// JLCast.h: macros over new cast operators

#ifndef INCL_JLCAST_H
#define INCL_JLCAST_H

// define HAVE_NEW_CAST_SUPPORT if your compiler has the new cast support
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
   #define HAVE_NEW_CAST_SUPPORT
#endif

#ifdef HAVE_NEW_CAST_SUPPORT
   #define STATIC_CAST(T,E)      (static_cast<T>(E))
   #define DYNAMIC_CAST(T,E)     (dynamic_cast<T>(E))
   #define REINTERPRET_CAST(T,E) (reinterpret_cast<T>(E))
   #define CONST_CAST(T,E)       (const_cast<T>(E))
#else
   #define STATIC_CAST(T,E)      ((T)E)
   #define DYNAMIC_CAST(T,E)     ((T)E)
   #define REINTERPRET_CAST(T,E) ((T)E)
   #define CONST_CAST(T,E)       ((T)E)
#endif

#endif
