// JLStringStream.h: Alternate lexer input stream from string

#ifndef INCL_JLSTRINGSTREAM_H
#define INCL_JLSTRINGSTREAM_H

#include "JLStr.h"
#include "DLexerBase.h"

///////////////////////////////////////////////////////////////////////
// This is a string-input stream for PCCTS that has nice
// semantics (e.g. the string is copied).
// The performance may not be specactular, however.
///////////////////////////////////////////////////////////////////////
class JLStringInputStream : public DLGInputStream {
public:
   JLStringInputStream(const JLStr& s) :
      input(s),
      pos(0)
    {}

   virtual int nextChar()
   {
      return (pos < (int)input.length() ? input[(size_t)pos++] : EOF);
   }
private:
   JLStr input;
   int pos;
};


#endif

