/* ATokPtr.h
 *
 * SOFTWARE RIGHTS
 *
 * We reserve no LEGAL rights to the Purdue Compiler Construction Tool
 * Set (PCCTS) -- PCCTS is in the public domain.  An individual or
 * company may do whatever they wish with source code distributed with
 * PCCTS or the code generated by PCCTS, including the incorporation of
 * PCCTS, or its output, into commerical software.
 * 
 * We encourage users to develop software with PCCTS.  However, we do ask
 * that credit is given to us for developing PCCTS.  By "credit",
 * we mean that if you incorporate our source code into one of your
 * programs (commercial product, research project, or otherwise) that you
 * acknowledge this fact somewhere in the documentation, research report,
 * etc...  If you like PCCTS and have developed a nice tool with the
 * output, please mention that you developed it using PCCTS.  In
 * addition, we ask that this header remain intact in our source code.
 * As long as these guidelines are kept, we expect to continue enhancing
 * this system and expect to make other tools available as they are
 * completed.
 *
 * Written by Russell Quong June 30, 1995
 * Adapted by Terence Parr to ANTLR stuff
 * Parr Research Corporation
 * with Purdue University and AHPCRC, University of Minnesota
 * 1989-1995
 *
 * ANTLR 1.33J
 * Mercilessly hacked by John Lilley 1996-97
 */

#ifndef INCL_ATokPtr_h
#define INCL_ATokPtr_h

#include "AToken.h"
#include "JLRefPtr.h"
#include <string.h>

typedef refcnt_ptr<ANTLRAbstractToken> ANTLRTokenPtrBase;

class ANTLRAbstractToken;

class ANTLRTokenPtr : public ANTLRTokenPtrBase {
public:
   ANTLRTokenPtr(ANTLRAbstractToken *addr=0) : ANTLRTokenPtrBase(addr) { }
   ANTLRTokenPtr(const ANTLRTokenPtrBase &rhs) : ANTLRTokenPtrBase(rhs) { }
   ~ANTLRTokenPtr() { }

   void operator=(const ANTLRTokenPtrBase& rhs) { 
      ANTLRTokenPtrBase::operator=(rhs);
   }
   void operator=(ANTLRAbstractToken *rhs)
   {
      ANTLRTokenPtrBase::operator=(rhs);
   }

   // Conversion to "dumb" pointer
   //operator ANTLRAbstractToken *() { return ptr_; }
   //operator const ANTLRAbstractToken *() const { return ptr_; }

   // Ordering operation that supports use of tokens
   // as keys in containers that require 'operator <' for ordering
   bool operator < (const ANTLRTokenPtr& rhs) const 
   { 
      return (strcmp((*this)->getText(), rhs->getText()) < 0);
   }
};

#endif
