/* ATokenBuffer.h
 *
 * SOFTWARE RIGHTS
 *
 * We reserve no LEGAL rights to the Purdue Compiler Construction Tool
 * Set (PCCTS) -- PCCTS is in the public domain.  An individual or
 * company may do whatever they wish with source code distributed with
 * PCCTS or the code generated by PCCTS, including the incorporation of
 * PCCTS, or its output, into commerical software.
 * 
 * We encourage users to develop software with PCCTS.  However, we do ask
 * that credit is given to us for developing PCCTS.  By "credit",
 * we mean that if you incorporate our source code into one of your
 * programs (commercial product, research project, or otherwise) that you
 * acknowledge this fact somewhere in the documentation, research report,
 * etc...  If you like PCCTS and have developed a nice tool with the
 * output, please mention that you developed it using PCCTS.  In
 * addition, we ask that this header remain intact in our source code.
 * As long as these guidelines are kept, we expect to continue enhancing
 * this system and expect to make other tools available as they are
 * completed.
 *
 * Terence Parr
 * Parr Research Corporation
 * with Purdue University and AHPCRC, University of Minnesota
 * 1989-1995
 *
 * ANTLR 1.33J
 * Mercilessly hacked by John Lilley 1996-97
 */

#ifndef INCL_ATOKENBUFFER_H
#define INCL_ATOKENBUFFER_H

#include "ATokPtr.h"

/*
 * The parser is "attached" to an ANTLRTokenBuffer via interface
 * functions: getToken() and bufferedToken().  The object that actually
 * consumes characters and constructs tokens is connected to the
 * ANTLRTokenBuffer via interface function ANTLRTokenStream::getToken();
 * where ANTLRTokenStream is really just a behavior (class with no data).
 */

class ANTLRAbstractToken;

// Token buffer base class
class ANTLRTokenBuffer {
public:
	virtual ~ANTLRTokenBuffer() {}

   // Consume the current token and shift the circular buffer
	virtual void consume() = 0;

   // Return a marker for future backtracking
	virtual int mark() = 0;

   // Rewind to a previously-set marker position
	virtual void rewind(int pos) = 0;

   // Discard a previously-set marker position
	virtual void unmark(int pos) = 0;

   // Get LT(i)
	virtual ANTLRTokenPtr LT(int i) = 0;
};

#endif
