/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */
#include <stdio.h>
#define ANTLR_VERSION	133
#include "tokens.h"
#include "MyZZPred.h"  
#include "AParser.h"
#include "Expr.h"
#include "DLexerBase.h"
#include "ATokPtr.h"
#ifndef PURIFY
#define PURIFY(r,s)
#endif

/* user must define ANTLRToken */
class ANTLRToken : public ANTLRAbstractToken {
	protected:
	ANTLRTokenType _type;	// what's the token type of the token object
	int _line;			// track line info for errors
	
	/* For our simple purposes, a token and a string is enough for
	* our attribute
	*/
	ANTLRChar _text[30];
	
public:
	ANTLRToken(ANTLRTokenType t, ANTLRChar *s)
	{ setType(t); _line = 0; setText(s); }
	
	/* Your derived class MUST have a blank constructor. */
	ANTLRToken()
	{ setType((ANTLRTokenType)0); _line = 0; setText(""); }
	
	// how to access the token type and line number stuff
	virtual int getLine() const { return _line; }
	void setLine(int line) { _line = line; }
	
	const ANTLRChar *getText() const { return _text; }
	void setText(const ANTLRChar *s) { strncpy(_text, s, 30); }
	
	/* WARNING WARNING WARNING: you must return a stream of distinct tokens */
	/* This function will disappear when I can use templates */
	virtual ANTLRAbstractToken *makeToken(ANTLRTokenType tt,
	ANTLRChar *txt,
	int line)
	{
	ANTLRAbstractToken *t = new ANTLRToken(tt,txt);
	t->setLine(line);
	return t;
}
};

/* "DLGLexer" must match what you use on DLG command line (-cl);
* "DLGLexer" is the default.
*/
#include "DLGLexer.h"		/* include definition of DLGLexer.
* This cannot be generated automatically because
* ANTLR has no idea what you will call this file
* with the DLG command-line options.
*/

int main()
{
DLGFileInput in(stdin);	/* create input stream for DLG to get chars from */
DLGLexer scan(&in);		/* create scanner reading from stdin */
ANTLRTokenBuffer pipe(&scan, 2);/* make buffered pipe between lexer&parser */
ANTLRTokenPtr aToken=new ANTLRToken; // create a token to fill in for DLG
scan.setToken(mytoken(aToken));
Expr parser(&pipe);		/* create parser of type Expr hooked to scanner */
parser.init();			/* init the parser; prime lookahead etc... */

	parser.r();				/* start parsing at rule 'r' of that parser */
return 0;
}

void
Expr::r(void)
{
	zzRULE;
	ANTLRParserState parserState;
	int _marker = 0;
	Tracer tracer(this, "r");
	int _success = 0;
	try {
		saveState(&parserState);
		guessing = 1;
		_marker = MarkInputTokens();
		{
			int _success = 0;
			_match(A);
						consume();
			_success = 1;
		}
		_match(B);
				consume();
		_success = 1;
		UnmarkInputTokens(_marker);
		guessing = parserState.guessing;   // restore only the guessing state
	} catch(AParserEX&) {
		_success = 0;
		RewindInputTokens(_marker);
		restoreState(&parserState);
	}
	return;
}
