/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */
#include <stdio.h>
#define ANTLR_VERSION	133
#include "../cpre/tokens.h"

#ifdef _MSC_VER
// Disable some warnings that appear commonly in Rogue Wave STL
#pragma warning (disable:4786)    // long debug names
#pragma warning (disable:4146)    // unary minus operator applied to unsigned type
#pragma warning (disable:4018)    // '>' : signed/unsigned mismatch
#endif
#include "CPPCommon.h"
#include "AParser.h"
#include "CPPParser.h"
#include "DLexerBase.h"
#include "ATokPtr.h"
#ifndef PURIFY
#define PURIFY(r,s)
#endif

  CPPConst::AccessSpecifier   
CPPParser::access_specifier(void)
{
	  CPPConst::AccessSpecifier   	 _retv;
	zzRULE;
	_retv = CPPConst::asNONE;   
	Tracer tracer(this, "access_specifier");
	int _success = 0;
	if ((LA(1)==TOK_PUBLIC) ) {
		_match(TOK_PUBLIC);
		
		_retv = CPPConst::asPUBLIC;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PROTECTED) ) {
		_match(TOK_PROTECTED);
		
		_retv = CPPConst::asPROTECTED;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PRIVATE) ) {
		_match(TOK_PRIVATE);
		
		_retv = CPPConst::asPRIVATE;   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err1);
	}
	return _retv;
}

void
CPPParser::base_clause(  CPPTypeRefI classType  )
{
	zzRULE;
	;  
	Tracer tracer(this, "base_clause");
	int _success = 0;
	;  
	_match(TOK_COLON);
		consume();
	base_specifier(   classType  );
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
						consume();
			base_specifier(   classType  );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

void
CPPParser::base_specifier(  CPPTypeRefI classType  )
{
	zzRULE;
	
	CPPConst::BaseSpecifier bs;
	CPPTypeRefI baseClassType;
	CPPScopeRefI scope;
	Tracer tracer(this, "base_specifier");
	int _success = 0;
	;  
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
			LA(1)==TOK_PUBLIC || LA(1)==TOK_VIRTUAL)))
				break;
			int _success = 0;
			if ((LA(1)==TOK_PUBLIC) ) {
				_match(TOK_PUBLIC);
				
				bs |= CPPConst::bsPUBLIC;   
				consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_PROTECTED) ) {
				_match(TOK_PROTECTED);
				
				bs |= CPPConst::bsPROTECTED;   
				consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_PRIVATE) ) {
				_match(TOK_PRIVATE);
				
				bs |= CPPConst::bsPRIVATE;   
				consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_VIRTUAL) ) {
				_match(TOK_VIRTUAL);
				
				bs |= CPPConst::bsVIRTUAL;   
				consume();
				_success = 1;
			}
			if ( !_success ) break; /* implied exit branch */
		}
	}
	  baseClassType   = qualified_type();

	AddBaseToClass( classType, baseClassType, bs);   
	_success = 1;
	return;
}

 CPPConst::TypeSpecifier  
CPPParser::builtin_type_specifier(void)
{
	 CPPConst::TypeSpecifier  	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	_retv = CPPConst::tsVOID;  
	Tracer tracer(this, "builtin_type_specifier");
	int _success = 0;
	;  
	_setmatch(BUILTIN_TOKCLASS_set);
	
	tok = (ANTLRTokenPtr)LT(1);

	
	switch ( tok->getType())
	{
		case TOK_VOID:
		_retv = CPPConst::tsVOID;
		break;
		case TOK_CHAR:
		_retv = CPPConst::tsCHAR;
		break;
		case TOK_WCHAR_T:
		_retv = CPPConst::tsWCHAR_T;
		break;
		case TOK_SHORT:
		_retv = CPPConst::tsSHORT;
		break;
		case TOK_INT:
		_retv = CPPConst::tsINT;
		break;
		case TOK_LONG:
		_retv = CPPConst::tsLONG;
		break;
		case TOK_FLOAT:
		_retv = CPPConst::tsFLOAT;
		break;
		case TOK_DOUBLE:
		_retv = CPPConst::tsDOUBLE;
		break;
		case TOK_SIGNED:
		_retv = CPPConst::tsSIGNED;
		break;
		case TOK_UNSIGNED:
		_retv = CPPConst::tsUNSIGNED;
		break;
		case TOK_BOOL:
		_retv = CPPConst::tsBOOL;
		break;
		
      // Compiler-specific extensions
		case TOK_MSEXT_INT8:
		_retv = CPPConst::tsCHAR;
		break;
		case TOK_MSEXT_INT16:
		_retv = CPPConst::tsSHORT;
		break;
		case TOK_MSEXT_INT32:
		_retv = CPPConst::tsLONG;
		break;
		case TOK_MSEXT_INT64:
		_retv = CPPConst::tsINT64;
		break;
		default:
		assert(0);
	}
	consume();
	_success = 1;
	return _retv;
}

CPPParser::_rv5
CPPParser::class_specifier(void)
{
	struct _rv5 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL, lcurly=NULL;
	
	ScopePopper scopePopper(this); 
	_retv.classType = (CPPType*)0;
	_retv.ts = CPPConst::tsNONE;
	bool dummy;
	Tracer tracer(this, "class_specifier");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_STRUCT) ) {
			_match(TOK_STRUCT);
			
			_retv.ts = CPPConst::tsSTRUCT;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_UNION) ) {
			_match(TOK_UNION);
			
			_retv.ts = CPPConst::tsUNION;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_CLASS) ) {
			_match(TOK_CLASS);
			
			_retv.ts = CPPConst::tsCLASS;  
			consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err3);
		}
	}
	  dummy   = scope_override();

	{
		int _success = 0;
		if ((LA(1)==TOK_ID) ) {
			_match(TOK_ID);
			
			id = (ANTLRTokenPtr)LT(1);
			consume();
			{
				;  
				int _success = 0;
				JLStr className;   
				
				TemplateArgumentListRefI argList; 
				bool haveArgList = false;
				{
					;  
					int _success = 0;
					if ((LA(1)==TOK_LESSTHAN) ) {
						
						bool tmpBool;
						ScopeSaver scopeSaver(this, scopePopper.Get());
						scopePopper.Restore();
						haveArgList = true;
						_match(TOK_LESSTHAN);
												consume();
						{ struct _rv95 _trv; _trv = template_argument_list();

						argList = _trv.argList; tmpBool   = _trv.usedInnerTemplateParms; }
						_match(TOK_GREATERTHAN);
						
						
						scopeSaver.Restore();
						scopeSaver.Commit();
						consume();
						_success = 1;
					}
				}
				{
					;  
					int _success = 0;
					if ((LA(1)==TOK_COLON || LA(1)==TOK_LCURLY) ) {
						
						JLStr tmpName =  id->getText();
						if (haveArgList)
						{
							tmpName = FormatClassSpecializationName(tmpName, argList);
						}
						
                        CPPDeclRefI tmpDecl;
						DefineClassType(
						tmpName,
						_retv.ts, 
						GetCurrentScope(), 
						id, 
						_retv.classType,
						tmpDecl,
						className
						);
						{
							;  
							int _success = 0;
							if ((LA(1)==TOK_COLON) ) {
								CommitGuess();   
								base_clause(  _retv.classType  );
								_success = 1;
							}
						}
						_match(TOK_LCURLY);
						
						CommitGuess();   
						consume();
						
						// enter new class scope
						EnterNamedScope(className, false);
						{
							while ( 1 ) {
								if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || 
								LA(1)==TOK_SEMICOLON || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
								LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || 
								LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
								LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
								LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
								LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
								LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
								LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
								LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || 
								LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA)))
									break;
								// try block for exception handling
								try {
									int _success = 0;
									declaration_member();
									_success = 1;
									if ( !_success ) break; /* implied exit branch */
								} catch(AParserEX& ex) {
									// catch phrase for exception handling
									if (guessing) {
										// Propagate the exception
										throw;
									} else {
										
										ReportExceptionError(ex);
										consume();
										consumeUntil(MEMBER_SYNC_TOKCLASS_set);
									}
								}
							}
						}
						_match(TOK_RCURLY);
												consume();
						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
					LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || 
					LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || 
					LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || 
					LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
					LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
						
						if (haveArgList)
						{
							// Class template specialization
							LookupSpecialization(
							id->getText(),
							argList,
							id,
							className,
							_retv.classType
							);
						} else {
							// Non-templated class declaration
							// Look up the class declaration if it already exists, or create 
							// an (incomplete) class declaration if it does not exist.
							// scope in which the decl is made is only specified if is an override
							CPPScopeRefI declScope;
							if (scopePopper.Get() != SaveScope())
							{
								declScope = GetCurrentScope();
							}
							CPPDeclRefI tmpDecl;
							DeclareClassType(
							id->getText(), 
							_retv.ts, 
							declScope,
							id, 
							_retv.classType, 
							tmpDecl,
							className
							);
						}
						_success = 1;
					}
					if (!_success) {
						fail_syntax(err4);
					}
				}
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LCURLY) ) {
			_match(TOK_LCURLY);
			
			lcurly = (ANTLRTokenPtr)LT(1);

			
			JLStr className;
			CPPDeclRefI tmpDecl;
			DefineClassType(
			"", 
			_retv.ts, 
			GetCurrentScope(),
			lcurly, 
			_retv.classType, 
			tmpDecl,
			className
			); 
			// enter new (unnamed) class scope
			EnterNamedScope(className, false);
			consume();
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || 
					LA(1)==TOK_SEMICOLON || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
					LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || 
					LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
					LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
					LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
					LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
					LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
					LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
					LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || 
					LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA)))
						break;
					// try block for exception handling
					try {
						int _success = 0;
						declaration_member();
						_success = 1;
						if ( !_success ) break; /* implied exit branch */
					} catch(AParserEX& ex) {
						// catch phrase for exception handling
						if (guessing) {
							// Propagate the exception
							throw;
						} else {
							
							ReportExceptionError(ex);
							consume();
							consumeUntil(MEMBER_SYNC_TOKCLASS_set);
						}
					}
				}
			}
			_match(TOK_RCURLY);
						consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err5);
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv6
CPPParser::class_specifier_simple(void)
{
	struct _rv6 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	ScopePopper scopePopper(this); 
	bool dummy;
	Tracer tracer(this, "class_specifier_simple");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_STRUCT) ) {
			_match(TOK_STRUCT);
			
			_retv.ts = CPPConst::tsSTRUCT;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_UNION) ) {
			_match(TOK_UNION);
			
			_retv.ts = CPPConst::tsUNION;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_CLASS) ) {
			_match(TOK_CLASS);
			
			_retv.ts = CPPConst::tsCLASS;  
			consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err6);
		}
	}
	  dummy   = scope_override();

	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LESSTHAN)&&(!(((LA(1)==TOK_LESSTHAN)))||(1)) ) {
			if (!(!(((LA(1)==TOK_LESSTHAN)))||(1))) {fail_predicate("  1");}
			{
				
				JLStr specializedClassName; 
				bool tmpBool;
				int _success = 0;
				{ struct _rv102 _trv; _trv = template_specialization(   id->getText(), scopePopper.Get(),  id  );

				specializedClassName = _trv.specializationName; _retv.classType = _trv.specializationType; tmpBool   = _trv.usedInnerTemplateParms; }
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOTEQUAL || 
		LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || 
		LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || 
		LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || 
		LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_AUTO || 
		LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
		LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			
			// scope in which the decl is made is only specified if is an override
			CPPScopeRefI declScope;
			if (scopePopper.Get() != SaveScope())
			{
				declScope = GetCurrentScope();
			}
			JLStr tmpName;
			CPPDeclRefI tmpDecl;
			DeclareClassType(
			id->getText(), 
			_retv.ts, 
			declScope,
			id, 
			_retv.classType, 
			tmpDecl,
			tmpName
			);
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err7);
		}
	}
	_success = 1;
	return _retv;
}

  CPPConst::CallingConvention   
CPPParser::compiler_specific_calling_convention(void)
{
	  CPPConst::CallingConvention   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "compiler_specific_calling_convention");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_MSEXT_CDECL) ) {
			_match(TOK_MSEXT_CDECL);
			
			_retv = CPPConst::ccCDECL;   
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_MSEXT_FASTCALL) ) {
			_match(TOK_MSEXT_FASTCALL);
			
			_retv = CPPConst::ccMS_FASTCALL;   
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_MSEXT_STDCALL) ) {
			_match(TOK_MSEXT_STDCALL);
			
			_retv = CPPConst::ccMS_STDCALL;   
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_ELLIPSIS || 
		LA(1)==TOK_GREATERTHAN || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_RPAREN || LA(1)==TOK_SCOPE || 
		LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || LA(1)==TOK_ID) ) {
			_retv = CPPConst::ccCDECL;   
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err8);
		}
	}
	_success = 1;
	return _retv;
}

  ANTLRTokenPtr   
CPPParser::constant(void)
{
	  ANTLRTokenPtr   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	_retv = (ANTLRAbstractToken*)0;   
	Tracer tracer(this, "constant");
	int _success = 0;
	;  
	_setmatch(CONSTANT_TOKCLASS_set);
	
	tok = (ANTLRTokenPtr)LT(1);

	_retv =  tok;   
	consume();
	_success = 1;
	return _retv;
}

CPPParser::_rv9
CPPParser::ctor_declarator(void)
{
	struct _rv9 _retv;
	zzRULE;
	
	CPPConst::CallingConvention cc;
	ScopePopper scopePopper(this);
	Tracer tracer(this, "ctor_declarator");
	int _success = 0;
	;  
	  cc   = compiler_specific_calling_convention();

	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				{ struct _rv74 _trv; _trv = qualified_id(  false, true, false  );

				_retv.declName = _trv.name; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
				if (!(IsEnclosingClassName(_retv.declName) )) {fail_predicate("   IsEnclosingClassName(_retv.declName) ");}
				
				// If there was a scope override in the qualified id, then
				// save the overridden scope, pop the scope stack, and re-enter
				// the scope, pulling in its context (namespace/base classes).
				_retv.declScope = GetCurrentScope();
				if (SaveScope() != scopePopper.Get())
				{
					scopePopper.Restore();
					EnterScopeContext(_retv.declScope, false);
				}
				
				if (LA(1) == TOK_LPAREN) 
				{
					CommitGuess(); 
				}
				{ struct _rv32 _trv; _trv = declarator_suffix_function(  LookupVoidType(), CPPConst::ccCDECL  );

				_retv.argNameList = _trv.argNameList; _retv.argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN) ) {
			_match(TOK_LPAREN);
						consume();
			{ struct _rv9 _trv; _trv = ctor_declarator();

			_retv.declName = _trv.declName; _retv.argNameList = _trv.argNameList; _retv.declScope = _trv.declScope; _retv.argScope = _trv.argScope; _retv.outputType = _trv.outputType; _retv.usedInnerTemplateParms  = _trv.usedInnerTemplateParms; }
			_match(TOK_RPAREN);
						consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err10);
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::ctor_initializer(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "ctor_initializer");
	int _success = 0;
	;  
	_match(TOK_COLON);
		consume();
	ctor_member_init();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
						consume();
			ctor_member_init();
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

void
CPPParser::ctor_member_init(void)
{
	zzRULE;
	
	ScopePopper scopePopper(this);
	JLStr memberInitName;
	bool tmpBool;
	Tracer tracer(this, "ctor_member_init");
	int _success = 0;
	;  
	{ struct _rv74 _trv; _trv = qualified_id(  true, false, false  );

	memberInitName = _trv.name; tmpBool   = _trv.usedInnerTemplateParms; }
	scopePopper.Restore();   
	_match(TOK_LPAREN);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
		LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			expression_list();
			_success = 1;
		}
	}
	_match(TOK_RPAREN);
		consume();
	_success = 1;
	return;
}

 CPPConst::CVQualifier  
CPPParser::cv_qualifier(void)
{
	 CPPConst::CVQualifier  	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "cv_qualifier");
	int _success = 0;
	if ((LA(1)==TOK_CONST) ) {
		;  
		_match(TOK_CONST);
		
		_retv = CPPConst::cvCONST;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_VOLATILE) ) {
		_match(TOK_VOLATILE);
		
		_retv = CPPConst::cvVOLATILE;  
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err11);
	}
	return _retv;
}

 CPPConst::CVQualifier  
CPPParser::cv_qualifier_seq(void)
{
	 CPPConst::CVQualifier  	 _retv;
	zzRULE;
	_retv = CPPConst::cvNONE;   
	Tracer tracer(this, "cv_qualifier_seq");
	int _success = 0;
	;  
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_CONST || LA(1)==TOK_VOLATILE)))
				break;
			int _success = 0;
			if ((LA(1)==TOK_CONST) ) {
				_match(TOK_CONST);
				
				_retv |= CPPConst::cvCONST;  
				consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_VOLATILE) ) {
				_match(TOK_VOLATILE);
				
				_retv |= CPPConst::cvVOLATILE;  
				consume();
				_success = 1;
			}
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::declaration_external(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "declaration_external");
	int _success = 0;
	;  
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_TYPEDEF)&&(!(((LA(1)==TOK_TYPEDEF)))||(GetOption(OptMSTypedefHack))) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				if (!(GetOption(OptMSTypedefHack))) {fail_predicate("  GetOption(OptMSTypedefHack)");}
				{
					int _success = 0;
					_match(TOK_TYPEDEF);
										consume();
					{
						int _success = 0;
						if ((LA(1)==TOK_UNSIGNED) ) {
							_match(TOK_UNSIGNED);
														consume();
							_match(TOK_SHORT);
														consume();
							_match(TOK_WCHAR_T);
														consume();
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_INT) ) {
							_match(TOK_INT);
														consume();
							_match(TOK_BOOL);
														consume();
							_success = 1;
						}
						if (!_success) {
							fail_syntax(err12);
						}
					}
					_match(TOK_SEMICOLON);
										consume();
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_EXTERN)&&(!(((LA(1)==TOK_EXTERN)))||(LT(2)->getType() == TOK_STRING)) ) {
			if (!(!(((LA(1)==TOK_EXTERN)))||(LT(2)->getType() == TOK_STRING))) {fail_predicate("  LT(2)->getType() == TOK_STRING");}
			linkage_specification();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
		LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
		LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
		LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
		LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
		LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
		LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			declaration_external_or_member(  false  );
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_PNDPRAGMA) ) {
			pragma_line();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err13);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::declaration_external_or_member(  bool memberDecl  )
{
	zzRULE;
	ScopePopper scopePopper(this);   
	Tracer tracer(this, "declaration_external_or_member");
	int _success = 0;
	if ((LA(1)==TOK_TEMPLATE) ) {
		;   
		template_declaration(  GetCurrentScope(), memberDecl  );
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
	LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
	LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
	LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
	LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
	LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
	LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
	LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || 
	LA(1)==TOK_ID) ) {
		
		CPPConst::StorageClass sc;
		CPPConst::DeclModifier dm;
		{ struct _rv18 _trv; _trv = declaration_sc_or_dm_seq();

		sc = _trv.sc; dm   = _trv.dm; }
		{
			ANTLRParserState parserState;
			int _marker = 0;
			int _success = 0;
			if ((LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
				try {
					saveState(&parserState);
					guessing = 1;
					_marker = MarkInputTokens();
					{
						
						JLStr ctorName;
						CPPDeclRefI ctorDecl; 
						CPPScopeRefI declScope;
						CPPScopeRefI argScope;
						CPPTypeRefI ctorType;
						bool tmpBool;
						StrListRefI argNameList;
						int _success = 0;
						{ struct _rv9 _trv; _trv = ctor_declarator();

						ctorName = _trv.declName; argNameList = _trv.argNameList; declScope = _trv.declScope; argScope = _trv.argScope; ctorType = _trv.outputType; tmpBool   = _trv.usedInnerTemplateParms; }
						
						// DWP says that a ctor is not entered into the class scope under
						// any name that can be searched.  So we use "$ctor".
						ctorDecl = DeclareObjectOrTypedef(
						"$ctor",
						ctorType,
						sc,
						dm,
						CPPExprRefI(),
						declScope,
						argNameList
						);
						{
							int _success = 0;
							if ((LA(1)==TOK_COLON || LA(1)==TOK_LCURLY) ) {
								{
									
									if (declScope != GetCurrentScope())
									{
										EnterScopeContext(declScope, false);
									}
									EnterScope(argScope, false);
									int _success = 0;
									{
										int _success = 0;
										if ((LA(1)==TOK_COLON) ) {
											ctor_initializer();
											_success = 1;
										}
									}
									{
										int _success = 0;
										if ((LA(1)==TOK_LCURLY)&&(!(((LA(1)==TOK_LCURLY)))||(memberDecl)) ) {
											if (!(!(((LA(1)==TOK_LCURLY)))||(memberDecl))) {fail_predicate("  memberDecl");}
											generic_block();
											_success = 1;
										}
										if ( !_success &&(LA(1)==TOK_LCURLY) ) {
											statement_compound();
											_success = 1;
										}
										if (!_success) {
											fail_syntax(err14);
										}
									}
									_success = 1;
								}
								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_SEMICOLON) ) {
								_match(TOK_SEMICOLON);
																consume();
								_success = 1;
							}
							if (!_success) {
								fail_syntax(err15);
							}
						}
						_success = 1;
					}
					_success = 1;
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;   // restore only the guessing state
				} catch(AParserEX&) {
					if (guessing) {
						_success = 0;
						RewindInputTokens(_marker);
						restoreState(&parserState);
					} else {
						// CommitGuess() was called -- treat as an error
						UnmarkInputTokens(_marker);
						guessing = parserState.guessing;
						throw;
					}
				}
			}
			if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
			LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
			LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
			LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
				{
					;  
					int _success = 0;
					CPPTypeRefI declSpecType;   
					{
						ANTLRParserState parserState;
						int _marker = 0;
						int _success = 0;
						if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
						LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
						LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
						LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
						LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID)&&(!(((
						LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || 
						LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || 
						LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
						LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
						LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID)))||(!set_el(LA(1), DECLSPEC_DECLARATOR_AMBIG_TOKCLASS_set))) ) {
							if (!(!set_el(LA(1), DECLSPEC_DECLARATOR_AMBIG_TOKCLASS_set))) {fail_predicate("  !set_el(LA(1), DECLSPEC_DECLARATOR_AMBIG_TOKCLASS_set)");}
							{ struct _rv19 _trv; _trv = declaration_specifiers(  sc, dm  );

							declSpecType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
						LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
						LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
						LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
						LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
							try {
								saveState(&parserState);
								guessing = 1;
								_marker = MarkInputTokens();
								{
									int _success = 0;
									{ struct _rv19 _trv; _trv = declaration_specifiers(  sc, dm  );

									declSpecType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
									_success = 1;
								}
								_success = 1;
								UnmarkInputTokens(_marker);
								guessing = parserState.guessing;   // restore only the guessing state
							} catch(AParserEX&) {
								if (guessing) {
									_success = 0;
									RewindInputTokens(_marker);
									restoreState(&parserState);
								} else {
									// CommitGuess() was called -- treat as an error
									UnmarkInputTokens(_marker);
									guessing = parserState.guessing;
									throw;
								}
							}
						}
						if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
						LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || 
						LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
							declSpecType = LookupVoidType();  
							_success = 1;
						}
						if (!_success) {
							fail_syntax(err16);
						}
					}
					{
						int _success = 0;
						if ((LA(1)==TOK_SEMICOLON) ) {
							_match(TOK_SEMICOLON);
														consume();
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
						LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || 
						LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
							declarator_function_or_init_list(  declSpecType, sc, dm, memberDecl  );
							_success = 1;
						}
						if (!_success) {
							fail_syntax(err17);
						}
					}
					_success = 1;
				}
				_success = 1;
			}
			if (!_success) {
				fail_syntax(err18);
			}
		}
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err19);
	}
	return;
}

void
CPPParser::declaration_member(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "declaration_member");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
		LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
		LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
		LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
		LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
		LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
		LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			declaration_external_or_member(  true  );
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC) ) {
			{
				CPPConst::AccessSpecifier as;   
				int _success = 0;
				 as  = access_specifier();

				SetCurrentScopeAccess(as);   
				_match(TOK_COLON);
								consume();
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_PNDPRAGMA) ) {
			pragma_line();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err20);
		}
	}
	_success = 1;
	return;
}

  CPPConst::DeclModifier   
CPPParser::declaration_modifier(void)
{
	  CPPConst::DeclModifier   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "declaration_modifier");
	int _success = 0;
	if ((LA(1)==TOK_INLINE) ) {
		;  
		_match(TOK_INLINE);
		
		_retv = CPPConst::dmINLINE;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_VIRTUAL) ) {
		_match(TOK_VIRTUAL);
		
		_retv = CPPConst::dmVIRTUAL;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_FRIEND) ) {
		_match(TOK_FRIEND);
		
		_retv = CPPConst::dmFRIEND;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_EXPLICIT) ) {
		_match(TOK_EXPLICIT);
		
		_retv = CPPConst::dmEXPLICIT;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_MSEXT_INLINE) ) {
		_match(TOK_MSEXT_INLINE);
		
		_retv = CPPConst::dmINLINE;   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err21);
	}
	return _retv;
}

CPPParser::_rv18
CPPParser::declaration_sc_or_dm_seq(void)
{
	struct _rv18 _retv;
	zzRULE;
	
	CPPConst::StorageClass sc2;
	CPPConst::DeclModifier dm2;
	Tracer tracer(this, "declaration_sc_or_dm_seq");
	int _success = 0;
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AUTO || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || 
			LA(1)==TOK_VIRTUAL || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE)))
				break;
			int _success = 0;
			if ((LA(1)==TOK_AUTO || LA(1)==TOK_EXTERN || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || 
			LA(1)==TOK_TYPEDEF || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC) ) {
				 sc2  = storage_class_specifier();

				_retv.sc |= sc2;   
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_EXPLICIT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_VIRTUAL || 
			LA(1)==TOK_MSEXT_INLINE) ) {
				  dm2   = declaration_modifier();

				_retv.dm |= dm2;   
				_success = 1;
			}
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv19
CPPParser::declaration_specifiers(  CPPConst::StorageClass scin, CPPConst::DeclModifier dmin  )
{
	struct _rv19 _retv;
	zzRULE;
	
	CPPConst::TypeSpecifier ts = CPPConst::tsNONE;
	CPPConst::TypeSpecifier ts2;
	CPPConst::CVQualifier cv = CPPConst::cvNONE;
	CPPConst::CVQualifier cv2;
	CPPConst::DeclModifier dm2;
	_retv.scout =  scin;
	_retv.dmout =  dmin;
	Tracer tracer(this, "declaration_specifiers");
	int _success = 0;
	;  
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_CONST || LA(1)==TOK_VOLATILE)))
				break;
			int _success = 0;
			 cv2  = cv_qualifier();

			cv |= cv2;   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
		LA(1)==TOK_MSEXT_INT64) ) {
			{
				ANTLRTokenPtr tok = LT(1);   
				int _success = 0;
				 ts2  = builtin_type_specifier();

				ts |= ts2;   
				{
					while ( 1 ) {
						if ( !((LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CONST || 
						LA(1)==TOK_DOUBLE || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || 
						LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || 
						LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || 
						LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
						LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE)))
							break;
						int _success = 0;
						if ((LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || LA(1)==TOK_FLOAT || 
						LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_UNSIGNED || 
						LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
						LA(1)==TOK_MSEXT_INT64) ) {
							 ts2  = builtin_type_specifier();

							ts |= ts2;   
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
						LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || 
						LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE) ) {
							{ struct _rv20 _trv; _trv = declaration_specifiers_qualifier( cv, _retv.scout, _retv.dmout  );

							cv = _trv.cvout; _retv.scout = _trv.scout; _retv.dmout   = _trv.dmout; }
							_success = 1;
						}
						if ( !_success ) break; /* implied exit branch */
					}
				}
				
				_retv.type = LookupBuiltinType(ts, tok);
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_CLASS || LA(1)==TOK_ENUM || LA(1)==TOK_STRUCT || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				if ((LA(1)==TOK_SCOPE || LA(1)==TOK_TYPENAME || LA(1)==TOK_ID) ) {
					  _retv.type   = qualified_type();

					ts = CPPConst::tsTYPEID;   
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_CLASS || LA(1)==TOK_STRUCT || LA(1)==TOK_UNION) ) {
					{ struct _rv5 _trv; _trv = class_specifier();

					_retv.type = _trv.classType; ts   = _trv.ts; }
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_ENUM) ) {
					  _retv.type   = enum_specifier();

					ts = CPPConst::tsENUM;   
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err22);
				}
			}
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || 
					LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || 
					LA(1)==TOK_TYPEDEF || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
					LA(1)==TOK_MSEXT_INLINE)))
						break;
					int _success = 0;
					{ struct _rv20 _trv; _trv = declaration_specifiers_qualifier( cv, _retv.scout, _retv.dmout  );

					cv = _trv.cvout; _retv.scout = _trv.scout; _retv.dmout   = _trv.dmout; }
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err23);
		}
	}
	_retv.type = LookupCVQualifierOfType(_retv.type, cv);   
	_success = 1;
	return _retv;
}

CPPParser::_rv20
CPPParser::declaration_specifiers_qualifier(  CPPConst::CVQualifier cvin, CPPConst::StorageClass scin, CPPConst::DeclModifier dmin  )
{
	struct _rv20 _retv;
	zzRULE;
	
	CPPConst::CVQualifier cv2;
	CPPConst::StorageClass sc2;
	CPPConst::DeclModifier dm2;
	// Initialize results
	_retv.scout =  scin;
	_retv.dmout =  dmin;
	_retv.cvout =  cvin;
	Tracer tracer(this, "declaration_specifiers_qualifier");
	int _success = 0;
	if ((LA(1)==TOK_AUTO || LA(1)==TOK_EXTERN || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || 
	LA(1)==TOK_TYPEDEF || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC) ) {
		;  
		 sc2  = storage_class_specifier();

		_retv.scout |= sc2;   
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_CONST || LA(1)==TOK_VOLATILE) ) {
		 cv2  = cv_qualifier();

		_retv.cvout |= cv2;   
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_EXPLICIT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_VIRTUAL || 
	LA(1)==TOK_MSEXT_INLINE) ) {
		  dm2   = declaration_modifier();

		_retv.dmout |= dm2;   
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err24);
	}
	return _retv;
}

CPPParser::_rv21
CPPParser::declaration_specifiers_simple(  CPPConst::StorageClass scin, CPPConst::DeclModifier dmin  )
{
	struct _rv21 _retv;
	zzRULE;
	
	CPPConst::TypeSpecifier ts = CPPConst::tsNONE;
	CPPConst::TypeSpecifier ts2;
	CPPConst::CVQualifier cv = CPPConst::cvNONE;
	CPPConst::CVQualifier cv2;
	CPPConst::DeclModifier dm2;
	_retv.scout =  scin;
	_retv.dmout =  dmin;
	Tracer tracer(this, "declaration_specifiers_simple");
	int _success = 0;
	;  
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_CONST || LA(1)==TOK_VOLATILE)))
				break;
			int _success = 0;
			 cv2  = cv_qualifier();

			cv |= cv2;   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
		LA(1)==TOK_MSEXT_INT64) ) {
			{
				ANTLRTokenPtr tok = LT(1);   
				int _success = 0;
				 ts2  = builtin_type_specifier();

				ts |= ts2;   
				{
					while ( 1 ) {
						if ( !((LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CONST || 
						LA(1)==TOK_DOUBLE || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || 
						LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || 
						LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || 
						LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
						LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE)))
							break;
						int _success = 0;
						if ((LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || LA(1)==TOK_FLOAT || 
						LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_UNSIGNED || 
						LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
						LA(1)==TOK_MSEXT_INT64) ) {
							 ts2  = builtin_type_specifier();

							ts |= ts2;   
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
						LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || 
						LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE) ) {
							{ struct _rv20 _trv; _trv = declaration_specifiers_qualifier( cv, _retv.scout, _retv.dmout  );

							cv = _trv.cvout; _retv.scout = _trv.scout; _retv.dmout   = _trv.dmout; }
							_success = 1;
						}
						if ( !_success ) break; /* implied exit branch */
					}
				}
				
				_retv.type = LookupBuiltinType(ts, tok);
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_CLASS || LA(1)==TOK_ENUM || LA(1)==TOK_STRUCT || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				if ((LA(1)==TOK_SCOPE || LA(1)==TOK_TYPENAME || LA(1)==TOK_ID) ) {
					  _retv.type   = qualified_type();

					ts = CPPConst::tsTYPEID;   
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_CLASS || LA(1)==TOK_STRUCT || LA(1)==TOK_UNION) ) {
					{ struct _rv6 _trv; _trv = class_specifier_simple();

					_retv.type = _trv.classType; ts   = _trv.ts; }
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_ENUM) ) {
					  _retv.type   = enum_specifier_simple();

					ts = CPPConst::tsENUM;   
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err25);
				}
			}
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || 
					LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || 
					LA(1)==TOK_TYPEDEF || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
					LA(1)==TOK_MSEXT_INLINE)))
						break;
					int _success = 0;
					{ struct _rv20 _trv; _trv = declaration_specifiers_qualifier( cv, _retv.scout, _retv.dmout  );

					cv = _trv.cvout; _retv.scout = _trv.scout; _retv.dmout   = _trv.dmout; }
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err26);
		}
	}
	_retv.type = LookupCVQualifierOfType(_retv.type, cv);   
	_success = 1;
	return _retv;
}

CPPParser::_rv22
CPPParser::declarator(  CPPTypeRefI inputType, CPPConst::CallingConvention cc  )
{
	struct _rv22 _retv;
	zzRULE;
	
	_retv.outputType =  inputType;
	CPPConst::CallingConvention cc2;
	ANTLRTokenPtr tok = LT(1);
	Tracer tracer(this, "declarator");
	int _success = 0;
	;  
	  cc2   = compiler_specific_calling_convention();

	
	if (cc != CPPConst::ccCDECL && cc2 != CPPConst::ccCDECL)
	{
		ReportError("Calling convention specified more than once", tok);
	}
	cc = cc2;
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_ID) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					int _success = 0;
					{ struct _rv23 _trv; _trv = declarator_direct(  _retv.outputType, cc  );

					_retv.declName = _trv.declName; _retv.argNameList = _trv.argNameList; _retv.declScope = _trv.declScope; _retv.argScope = _trv.argScope; _retv.outputType = _trv.outputType; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || LA(1)==TOK_ID) ) {
			  _retv.outputType   = declarator_ptr(  _retv.outputType  );

			{ struct _rv22 _trv; _trv = declarator(  _retv.outputType, cc  );

			_retv.declName = _trv.declName; _retv.argNameList = _trv.argNameList; _retv.declScope = _trv.declScope; _retv.argScope = _trv.argScope; _retv.outputType = _trv.outputType; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err27);
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv23
CPPParser::declarator_direct(  CPPTypeRefI inputType, CPPConst::CallingConvention cc  )
{
	struct _rv23 _retv;
	zzRULE;
	
	// Initialize values to something usable
	_retv.outputType =  inputType;
	_retv.declScope = GetCurrentScope(); 
	ScopePopper scopePopper(this); 
	Tracer tracer(this, "declarator_direct");
	int _success = 0;
	;   
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_ID) ) {
			{ struct _rv74 _trv; _trv = qualified_id(  true, true, false  );

			_retv.declName = _trv.name; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
			
			// If there was a scope override, then save the override scope,
			// pop the scope stack, and re-enter the override scope,
			// pulling in context (namespaces/base classes).
			if (SaveScope() != scopePopper.Get())
			{
				_retv.declScope = GetCurrentScope();
				scopePopper.Restore(); 
				EnterScopeContext(_retv.declScope, false);
			}
			{ struct _rv33 _trv; _trv = declarator_suffixes(  _retv.outputType, cc  );

			_retv.argNameList = _trv.argNameList; _retv.argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN) ) {
			{
				
				CPPTypeRefI tmpType1;
				CPPTypeRefI tmpType2;
				StrListRefI argNameList2;
				int _success = 0;
				_match(TOK_LPAREN);
				
				
				tmpType1 = CreateTempType(); 
				// ignore nested-declarator function parms scope
				CPPScopeRefI tmpScope;  
				consume();
				{ struct _rv22 _trv; _trv = declarator(  tmpType1, cc  );

				_retv.declName = _trv.declName; _retv.argNameList = _trv.argNameList; _retv.declScope = _trv.declScope; tmpScope = _trv.argScope; tmpType2 = _trv.outputType; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
				
				if (_retv.declScope != GetCurrentScope())
				{
					EnterScopeContext(_retv.declScope, false);
				}
				_match(TOK_RPAREN);
								consume();
				{ struct _rv33 _trv; _trv = declarator_suffixes(  _retv.outputType, cc  );

				argNameList2 = _trv.argNameList; _retv.argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
				
				// Figure out where the function arguments come from
				if (tmpType2 == tmpType1)
				{
					// exterior function suffix
					_retv.argNameList = argNameList2;
				}
				
               // Apply all of the type modifiers hanging off of tmpType1
				// to the outputType created by declarator_suffixes
				_retv.outputType = MergeTypeModifiers(_retv.outputType, tmpType1);
				_success = 1;
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err28);
		}
	}
	scopePopper.Commit();   
	_success = 1;
	return _retv;
}

void
CPPParser::declarator_function_or_init_list(  
   CPPTypeRefI declSpecType, 
   CPPConst::StorageClass sc, 
   CPPConst::DeclModifier dm,
   bool memberDecl
 )
{
	zzRULE;
	
	ScopePopper scopePopper(this);
	CPPTypeRefI declaratorType; 
	CPPExprRefI initExpr;
	CPPScopeRefI declScope;
	CPPScopeRefI argScope;
	JLStr declName;
	StrListRefI argNameList;
	bool tmpBool;
	Tracer tracer(this, "declarator_function_or_init_list");
	int _success = 0;
	;  
	{ struct _rv22 _trv; _trv = declarator(   declSpecType, CPPConst::ccCDECL  );

	declName = _trv.declName; argNameList = _trv.argNameList; declScope = _trv.declScope; argScope = _trv.argScope; declaratorType = _trv.outputType; tmpBool   = _trv.usedInnerTemplateParms; }
	{
		int _success = 0;
		if ((LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_LPAREN || LA(1)==TOK_SEMICOLON) ) {
			{
				int _success = 0;
				{
					int _success = 0;
					if ((LA(1)==TOK_ASSIGNEQUAL) ) {
						_match(TOK_ASSIGNEQUAL);
												consume();
						  initExpr   = initializer();

						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_LPAREN) ) {
						_match(TOK_LPAREN);
												consume();
						  initExpr   = expression_list();

						_match(TOK_RPAREN);
												consume();
						_success = 1;
					}
				}
				
				DeclareObjectOrTypedef(
				declName,
				declaratorType,
				sc,
				dm,
				initExpr,
				declScope,
				argNameList
				);
				{
					int _success = 0;
					if ((LA(1)==TOK_COMMA) ) {
						_match(TOK_COMMA);
												consume();
						declarator_init_list(   declSpecType,  sc,  dm  );
						_success = 1;
					}
				}
				_match(TOK_SEMICOLON);
								consume();
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LCURLY) ) {
			
			DeclareObjectOrTypedef(
			declName,
			declaratorType,
			sc,
			dm,
			CPPExprRefI(),
			declScope,
			argNameList
			);
			{
				int _success = 0;
				if ((LA(1)==TOK_LCURLY)&&(!(((LA(1)==TOK_LCURLY)))||(memberDecl)) ) {
					if (!(!(((LA(1)==TOK_LCURLY)))||(memberDecl))) {fail_predicate("  memberDecl");}
					generic_block();
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_LCURLY) ) {
					
					if (declScope != GetCurrentScope())
					{
						// Re-enter the decl's scope override for the function body
						EnterScopeContext(declScope, false);
					}
					EnterScope(argScope, false);
					statement_compound();
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err29);
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err30);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::declarator_init(  CPPTypeRefI inputType, CPPConst::StorageClass sc, CPPConst::DeclModifier dm   )
{
	zzRULE;
	
	CPPTypeRefI declaratorType; 
	CPPExprRefI initExpr;
	CPPScopeRefI declScope;
	CPPScopeRefI argScope;
	JLStr declName;
	StrListRefI argNameList;
	bool tmpBool;
	Tracer tracer(this, "declarator_init");
	int _success = 0;
	;  
	{ struct _rv22 _trv; _trv = declarator(   inputType, CPPConst::ccCDECL  );

	declName = _trv.declName; argNameList = _trv.argNameList; declScope = _trv.declScope; argScope = _trv.argScope; declaratorType = _trv.outputType; tmpBool   = _trv.usedInnerTemplateParms; }
	{
		int _success = 0;
		if ((LA(1)==TOK_ASSIGNEQUAL) ) {
			_match(TOK_ASSIGNEQUAL);
						consume();
			  initExpr   = initializer();

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN) ) {
			_match(TOK_LPAREN);
						consume();
			  initExpr   = expression_list();

			_match(TOK_RPAREN);
						consume();
			_success = 1;
		}
	}
	
	DeclareObjectOrTypedef(
	declName,
	declaratorType,
	sc,
	dm,
	initExpr,
	declScope,
	argNameList
	);
	_success = 1;
	return;
}

void
CPPParser::declarator_init_list(  CPPTypeRefI declSpecType, CPPConst::StorageClass sc, CPPConst::DeclModifier dm   )
{
	zzRULE;
	;   
	Tracer tracer(this, "declarator_init_list");
	int _success = 0;
	;   
	declarator_init(  declSpecType, sc, dm  );
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
						consume();
			declarator_init(  declSpecType, sc, dm   );
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

CPPParser::_rv27
CPPParser::declarator_opt_abstract(  CPPTypeRefI inputType  )
{
	struct _rv27 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	StrListRefI dummyNameList;
	CPPConst::CallingConvention cc;
	ScopePopper scopePopper(this);
	_retv.outputType =  inputType;
	Tracer tracer(this, "declarator_opt_abstract");
	int _success = 0;
	;  
	  cc   = compiler_specific_calling_convention();

	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || LA(1)==TOK_ID)&&(!(((
		LA(1)==TOK_ID)))||(LT(2)->getType() == TOK_SCOPE || LT(2)->getType() == TOK_LESSTHAN)) ) {
			if (!(!(((LA(1)==TOK_ID)))||(LT(2)->getType() == TOK_SCOPE || LT(2)->getType() == TOK_LESSTHAN))) {fail_predicate("  LT(2)->getType() == TOK_SCOPE || LT(2)->getType() == TOK_LESSTHAN");}
			  _retv.outputType   = declarator_ptr(  _retv.outputType  );

			{ struct _rv27 _trv; _trv = declarator_opt_abstract(  _retv.outputType  );

			_retv.declName = _trv.declName; _retv.outputType   = _trv.outputType; }
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN || LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				if ((LA(1)==TOK_LPAREN) ) {
					{
						
						CPPTypeRefI tmpType1;
						CPPTypeRefI dummyType;
						int _success = 0;
						_match(TOK_LPAREN);
						
						
						tmpType1 = CreateTempType(); 
						CPPScopeRefI argScope;
						consume();
						{ struct _rv27 _trv; _trv = declarator_opt_abstract(  tmpType1  );

						_retv.declName = _trv.declName; dummyType   = _trv.outputType; }
						_match(TOK_RPAREN);
												consume();
						{
							int _success = 0;
							if ((LA(1)==TOK_LPAREN) ) {
								{ struct _rv32 _trv; _trv = declarator_suffix_function(  _retv.outputType, cc  );

								dummyNameList = _trv.argNameList; argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_LSQUARE) ) {
								  _retv.outputType   = declarator_suffix_array(  _retv.outputType  );

								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_GREATERTHAN || 
							LA(1)==TOK_RPAREN) ) {
								_success = 1;
							}
							if (!_success) {
								fail_syntax(err31);
							}
						}
						
						_retv.outputType = MergeTypeModifiers(_retv.outputType, tmpType1);
						_success = 1;
					}
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_ID) ) {
					_match(TOK_ID);
					
					id = (ANTLRTokenPtr)LT(1);

					
					_retv.declName =  id->getText(); 
					CPPScopeRefI argScope;
					consume();
					{
						int _success = 0;
						if ((LA(1)==TOK_LPAREN) ) {
							{ struct _rv32 _trv; _trv = declarator_suffix_function(  _retv.outputType, cc  );

							dummyNameList = _trv.argNameList; argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_LSQUARE) ) {
							  _retv.outputType   = declarator_suffix_array(  _retv.outputType  );

							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_GREATERTHAN || 
						LA(1)==TOK_RPAREN) ) {
							_success = 1;
						}
						if (!_success) {
							fail_syntax(err32);
						}
					}
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err33);
				}
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LSQUARE) ) {
			  _retv.outputType   = declarator_suffix_array(  _retv.outputType  );

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_GREATERTHAN || 
		LA(1)==TOK_RPAREN) ) {
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err34);
		}
	}
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::declarator_ptr(  CPPTypeRefI inputType  )
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	CPPConst::CVQualifier cv;   
	Tracer tracer(this, "declarator_ptr");
	int _success = 0;
	_retv =  inputType;   
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND) ) {
			_match(TOK_AMPERSAND);
			
			_retv = LookupReferenceToType( inputType);   
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_STAR) ) {
			_match(TOK_STAR);
			
			_retv = LookupPointerToType( inputType);   
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_ID) ) {
			  _retv   = declarator_ptr_to_member(  _retv  );

			_success = 1;
		}
		if (!_success) {
			fail_syntax(err35);
		}
	}
	  cv   = cv_qualifier_seq();

	_retv = LookupCVQualifierOfType(_retv, cv);   
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::declarator_ptr_to_member(  CPPTypeRefI inputType  )
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	
	ScopePopper scopePopper(this);
	_retv =  inputType;
	CPPTypeRefI classType;
	ANTLRTokenPtr errTok;
	Tracer tracer(this, "declarator_ptr_to_member");
	int _success = 0;
	;   
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE) ) {
			_match(TOK_SCOPE);
			
			EnterResolvedGlobalScope();   
			consume();
			_success = 1;
		}
	}
	
	errTok = LT(1); 
	bool tmpBool;
	{ struct _rv77 _trv; _trv = scope_segment(  scopePopper.Get(), false, true  );

	classType = _trv.classType; tmpBool   = _trv.usedInnerTemplateParms; }
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_TEMPLATE || LA(1)==TOK_ID)))
				break;
			int _success = 0;
			if (!(IsScopeSegment(1, true) )) {fail_predicate("   IsScopeSegment(1, true) ");}
			bool isTemplate = false;   
			{
				int _success = 0;
				if ((LA(1)==TOK_TEMPLATE) ) {
					_match(TOK_TEMPLATE);
					
					isTemplate = true;  
					consume();
					_success = 1;
				}
			}
			errTok = LT(1);   
			{ struct _rv77 _trv; _trv = scope_segment(  scopePopper.Get(), isTemplate, true  );

			classType = _trv.classType; tmpBool   = _trv.usedInnerTemplateParms; }
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_match(TOK_STAR);
	
	
	// It is possible for classType to be zero if the last scope_segment
	// specified a namespace instead of a scope.
	if (classType.get() == 0)
	{
		ReportError(JLStr("'") + errTok->getText() + "' is not a class name", errTok);
	} else {
		_retv = LookupPointerToMemberOfType( inputType, classType, errTok);
	}
	consume();
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::declarator_suffix_array(  CPPTypeRefI inputType  )
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	
	_retv =  inputType;
	CPPExprRefI exprDimension;
	ANTLRTokenPtr errTok = LT(1);
	Tracer tracer(this, "declarator_suffix_array");
	int _success = 0;
	;   
	_match(TOK_LSQUARE);
		consume();
	{
		errTok = LT(1);   
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
		LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			  exprDimension   = expr_constant();

			_success = 1;
		}
	}
	_match(TOK_RSQUARE);
	
	_retv = LookupArrayOfType(_retv, exprDimension, errTok);   
	consume();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_LSQUARE)))
				break;
			int _success = 0;
			_match(TOK_LSQUARE);
			
			errTok = LT(1);   
			consume();
			{
				int _success = 0;
				if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
				LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
				LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
				LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
				LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
				LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
				LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
				LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
				LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
				LA(1)==TOK_CHARACTER) ) {
					  exprDimension   = expr_constant();

					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_RSQUARE) ) {
					
					ReportError("empty [] only allowed for first dimension", errTok);
					exprDimension = MakeExprLiteral(TOK_DECIMALINT, "1");
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err36);
				}
			}
			_match(TOK_RSQUARE);
			
			_retv = LookupArrayOfType(_retv, exprDimension, errTok);   
			consume();
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::declarator_suffix_bitfield(  CPPTypeRefI inputType  )
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	
	ANTLRTokenPtr errTok;
	CPPExprRefI exprFieldlen;
	_retv =  inputType;
	Tracer tracer(this, "declarator_suffix_bitfield");
	int _success = 0;
	;   
	_match(TOK_COLON);
	
	errTok = LT(1);   
	consume();
	  exprFieldlen   = expr_constant();

	_retv = LookupBitfieldOfType( inputType, exprFieldlen, errTok);   
	_success = 1;
	return _retv;
}

CPPParser::_rv32
CPPParser::declarator_suffix_function(  CPPTypeRefI inputType, CPPConst::CallingConvention cc  )
{
	struct _rv32 _retv;
	zzRULE;
	
	CPPConst::CVQualifier cv;
	_retv.outputType = LookupFunctionReturningType( inputType, cc); 
	ScopePopper scopePopper(this);
	EnterLocalScope();
	_retv.argScope = GetCurrentScope();
	Tracer tracer(this, "declarator_suffix_function");
	int _success = 0;
	;   
	_match(TOK_LPAREN);
		consume();
	{ struct _rv72 _trv; _trv = parameter_list_opt(  _retv.outputType  );

	_retv.argNameList = _trv.argNameList; _retv.outputType   = _trv.outputType; }
	_match(TOK_RPAREN);
		consume();
	  cv   = cv_qualifier_seq();

	_retv.outputType = LookupCVQualifierOfType(_retv.outputType, cv);   
	_success = 1;
	return _retv;
}

CPPParser::_rv33
CPPParser::declarator_suffixes(  CPPTypeRefI inputType, CPPConst::CallingConvention cc  )
{
	struct _rv33 _retv;
	zzRULE;
	
	_retv.outputType =  inputType;
	Tracer tracer(this, "declarator_suffixes");
	int _success = 0;
	;  
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_LSQUARE) ) {
			  _retv.outputType   = declarator_suffix_array(   inputType  );

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					int _success = 0;
					{ struct _rv32 _trv; _trv = declarator_suffix_function(   inputType, cc  );

					_retv.argNameList = _trv.argNameList; _retv.argScope = _trv.argScope; _retv.outputType   = _trv.outputType; }
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_COLON) ) {
			  _retv.outputType   = declarator_suffix_bitfield(   inputType  );

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_LCURLY || LA(1)==TOK_LPAREN || 
		LA(1)==TOK_RPAREN || LA(1)==TOK_SEMICOLON) ) {
			_retv.outputType =  inputType;   
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err37);
		}
	}
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::enum_specifier(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	CPPTypeRefI constEnumType; 
	ScopePopper scopePopper(this);
	bool dummy;
	Tracer tracer(this, "enum_specifier");
	int _success = 0;
	;  
	_match(TOK_ENUM);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LCURLY) ) {
			_match(TOK_LCURLY);
			
			
			// Cannot be an init-action
			JLStr tmpName;
			CPPDeclRefI tmpDecl;
			DefineEnumType("", GetCurrentScope(), LT(1), _retv, tmpDecl, tmpName);
			constEnumType = LookupCVQualifierOfType(_retv, CPPConst::cvCONST);
			consume();
			enumerator_list(  constEnumType  );
			_match(TOK_RCURLY);
						consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_ID) ) {
			  dummy   = scope_override();

			_match(TOK_ID);
			
			id = (ANTLRTokenPtr)LT(1);
			consume();
			{
				int _success = 0;
				if ((LA(1)==TOK_LCURLY) ) {
					_match(TOK_LCURLY);
					
					
					// Report error for explicit qualification
					if (scopePopper.Get() != SaveScope())
					{
						ReportError("Enum definitions cannot be explicitly-qualified",  id);
					}
					
                  JLStr tmpName;
					CPPDeclRefI tmpDecl;
					DefineEnumType(
					id->getText(), 
					GetCurrentScope(), 
					id, 
					_retv, 
					tmpDecl, 
					tmpName
					); 
					constEnumType = LookupCVQualifierOfType(_retv, CPPConst::cvCONST);
					consume();
					enumerator_list(  constEnumType  );
					_match(TOK_RCURLY);
										consume();
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
				LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || 
				LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || 
				LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || 
				LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
				LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
					
					if (LT(1)->getType() == TOK_SEMICOLON)
					{
						// Declaration
						
                     // Specify scope for decl iff there is an override, otherwise
						// use implicit scope stack lookup.
						CPPScopeRefI declScope;
						if (scopePopper.Get() != SaveScope())
						{
							declScope = GetCurrentScope();
						}
						
                     JLStr tmpName;
						CPPDeclRefI tmpDecl;
						DeclareEnumType(
						id->getText(), 
						declScope,
						id, 
						_retv, 
						tmpDecl, 
						tmpName
						); 
					} else {
						// Lookup of previously-declared enumeration
						// TODO: lookup explicitly-qualified enum
						_retv = LookupEnum( id->getText(),  id);
					}
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err38);
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err39);
		}
	}
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::enum_specifier_simple(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	CPPTypeRefI constEnumType; 
	ScopePopper scopePopper(this);
	bool dummy;
	Tracer tracer(this, "enum_specifier_simple");
	int _success = 0;
	;  
	_match(TOK_ENUM);
		consume();
	  dummy   = scope_override();

	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);

	
	if (LT(1)->getType() == TOK_SEMICOLON)
	{
		// Declaration
		JLStr tmpName;
		CPPDeclRefI tmpDecl;
		DeclareEnumType( id->getText(), GetCurrentScope(),  id, _retv, tmpDecl, tmpName); 
	} else {
		// Lookup of previously-declared enumeration
		_retv = LookupEnum( id->getText(),  id);
	}
	consume();
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::enumerator(  CPPTypeRefI enumType, CPPExprRefI exprIn  )
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	ANTLRTokenPtr errTok = LT(1);   
	Tracer tracer(this, "enumerator");
	int _success = 0;
	;  
	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_ASSIGNEQUAL) ) {
			_match(TOK_ASSIGNEQUAL);
			
			errTok = LT(1);   
			consume();
			  _retv   = expr_constant();

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_COMMA || LA(1)==TOK_RCURLY) ) {
			_retv =  exprIn;   
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err40);
		}
	}
	DeclareEnumerator( id->getText(),  enumType, _retv, errTok);   
	_success = 1;
	return _retv;
}

void
CPPParser::enumerator_list(  CPPTypeRefI enumType  )
{
	zzRULE;
	CPPExprRefI exprValue = MakeExprLiteral(TOK_DECIMALINT, "0");   
	Tracer tracer(this, "enumerator_list");
	int _success = 0;
	;  
	  exprValue   = enumerator(   enumType, exprValue  );

	
	exprValue = MakeExprBinary(
	exprValue,
	MakeExprLiteral(TOK_DECIMALINT, "1"),
	TOK_PLUS
	);
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)&&(!(((LA(1)==TOK_COMMA)))||(LT(2)->getType() == TOK_ID))))
				break;
			int _success = 0;
			if (!(!(((
			LA(1)==TOK_COMMA)))||(LT(2)->getType() == TOK_ID))) {fail_predicate("  LT(2)->getType() == TOK_ID");}
			_match(TOK_COMMA);
						consume();
			  exprValue   = enumerator(   enumType, exprValue  );

			
			exprValue = MakeExprBinary(
			exprValue,
			MakeExprLiteral(TOK_DECIMALINT, "1"),
			TOK_PLUS
			);
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_COMMA) ) {
			_match(TOK_COMMA);
						consume();
			_success = 1;
		}
	}
	_success = 1;
	return;
}

  CPPExprRefI   
CPPParser::expression(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expression");
	int _success = 0;
	;  
	  _retv   = expr_assignment();

	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
			
			CPPExprRefI expr2;  
			consume();
			  expr2   = expr_assignment();

			_retv = MakeExprBinary(_retv, expr2, TOK_COMMA);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expression_list(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	Tracer tracer(this, "expression_list");
	int _success = 0;
	  _retv   = expression();

	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_additive(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_additive");
	int _success = 0;
	;  
	  _retv   = expr_multiplicative();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_MINUS || LA(1)==TOK_PLUS)))
				break;
			int _success = 0;
			_setmatch(ADDITIVE_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_multiplicative();

			_retv = MakeExprBinary(_retv, expr2,  tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_and(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_and");
	int _success = 0;
	;  
	  _retv   = expr_equality();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((
			LA(1)==TOK_AMPERSAND)))
				break;
			int _success = 0;
			_match(TOK_AMPERSAND);
						consume();
			  expr2   = expr_equality();

			_retv = MakeExprBinary(_retv, expr2, TOK_AMPERSAND);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_assignment(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_assignment");
	int _success = 0;
	;  
	  _retv   = expr_conditional();

	{
		int _success = 0;
		if ((LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOREQUAL || 
		LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MODEQUAL || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_TIMESEQUAL) ) {
			_setmatch(ASSIGN_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);

			CPPExprRefI expr2;  
			consume();
			  expr2   = expr_assignment();

			_retv = MakeExprBinary(_retv, expr2,  tok->getType());   
			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_cast(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_cast");
	int _success = 0;
	;  
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_LPAREN) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					CPPTypeRefI type;   
					int _success = 0;
					_match(TOK_LPAREN);
										consume();
					  type   = type_name();

					_match(TOK_RPAREN);
										consume();
					  _retv   = expr_cast();

					_retv = MakeExprTraditionalCast(type, _retv);   
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
		LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			  _retv   = expr_unary();

			_success = 1;
		}
		if (!_success) {
			fail_syntax(err43);
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_conditional(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_conditional");
	int _success = 0;
	;  
	  _retv   = expr_logical_or();

	{
		CPPExprRefI lhs, rhs;   
		int _success = 0;
		if ((LA(1)==TOK_QUESTIONMARK) ) {
			_match(TOK_QUESTIONMARK);
						consume();
			  lhs   = expression();

			_match(TOK_COLON);
						consume();
			  rhs   = expr_logical_or();

			_retv = MakeExprConditional(_retv, lhs, rhs);   
			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_constant(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_constant");
	int _success = 0;
	;  
	  _retv   = expr_conditional();

	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_delete(  bool global  )
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	bool deleteArray = false;  
	Tracer tracer(this, "expr_delete");
	int _success = 0;
	;  
	_match(TOK_DELETE);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LSQUARE) ) {
			_match(TOK_LSQUARE);
						consume();
			_match(TOK_RSQUARE);
			
			deleteArray = true;   
			consume();
			_success = 1;
		}
	}
	  _retv   = expr_cast();

	_retv = MakeExprDelete(_retv, deleteArray);   
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_equality(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_equality");
	int _success = 0;
	;  
	  _retv   = expr_relational();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_EQUAL || LA(1)==TOK_NOTEQUAL)))
				break;
			int _success = 0;
			_setmatch(EQUALITY_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_relational();

			_retv = MakeExprBinary(_retv, expr2,  tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_exclusive_or(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_exclusive_or");
	int _success = 0;
	;  
	  _retv   = expr_and();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_BITWISEXOR)))
				break;
			int _success = 0;
			_match(TOK_BITWISEXOR);
						consume();
			  expr2   = expr_and();

			_retv = MakeExprBinary(_retv, expr2, TOK_BITWISEXOR);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_id(  CPPExprRefI objectExpr  )
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	
	ScopePopper scopePopper(this);
	JLStr exprIdName;
	ANTLRTokenPtr errTok = LT(1);
	bool tmpBool;
	Tracer tracer(this, "expr_id");
	int _success = 0;
	;  
	
	if ( objectExpr.get() != 0)
	{
		EnterExprScope( objectExpr, true);
	}
	{ struct _rv74 _trv; _trv = qualified_id(  false, false,  objectExpr.get()!=0  );

	exprIdName = _trv.name; tmpBool   = _trv.usedInnerTemplateParms; }
	
	_retv = LookupExprId(exprIdName, errTok);
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_inclusive_or(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_inclusive_or");
	int _success = 0;
	;  
	  _retv   = expr_exclusive_or();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((
			LA(1)==TOK_BITWISEOR)))
				break;
			int _success = 0;
			_match(TOK_BITWISEOR);
						consume();
			  expr2   = expr_exclusive_or();

			_retv = MakeExprBinary(_retv, expr2, TOK_BITWISEOR);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_literal(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr strTok=NULL;
	;  
	Tracer tracer(this, "expr_literal");
	int _success = 0;
	if ((LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || 
	LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_CHARACTER) ) {
		;  
		{
			ANTLRTokenPtr literalTok;   
			int _success = 0;
			  literalTok   = constant();

			
			// token may be empty if there was a syntax error
			if (literalTok.operator->() != 0)
			{
				_retv = MakeExprLiteral(literalTok->getType(), literalTok->getText());
			}
			_success = 1;
		}
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_STRING) ) {
		{
			JLStr str;   
			int _success = 0;
			{
				int zzcnt=1;
				do {
					int _success = 0;
					if ((LA(1)==TOK_STRING) ) {
						_match(TOK_STRING);
						
						strTok = (ANTLRTokenPtr)LT(1);

						str +=  strTok->getText();   
						consume();
						_success = 1;
					}
					if ( !_success && zzcnt>1 ) break; /* implied exit branch */
					if (!_success) {
						fail_syntax(err45);
					}
					zzcnt++;
				} while ( 1 );
			}
			_retv = MakeExprLiteral(TOK_STRING, str.c_str());   
			_success = 1;
		}
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err46);
	}
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_logical_and(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_logical_and");
	int _success = 0;
	;  
	  _retv   = expr_inclusive_or();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_AND)))
				break;
			int _success = 0;
			_match(TOK_AND);
						consume();
			  expr2   = expr_inclusive_or();

			_retv = MakeExprBinary(_retv, expr2, TOK_AND);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_logical_or(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_logical_or");
	int _success = 0;
	;  
	  _retv   = expr_logical_and();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_OR)))
				break;
			int _success = 0;
			_match(TOK_OR);
						consume();
			  expr2   = expr_logical_and();

			_retv = MakeExprBinary(_retv, expr2, TOK_OR);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_multiplicative(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_multiplicative");
	int _success = 0;
	;  
	  _retv   = expr_pm();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_DIVIDE || 
			LA(1)==TOK_MOD || LA(1)==TOK_STAR)))
				break;
			int _success = 0;
			_setmatch(MULTIPLICATIVE_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_pm();

			_retv = MakeExprBinary(_retv, expr2,  tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_new(  bool global  )
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	
	CPPExprRefI placementExpr;
	CPPExprRefI arraySizeExpr;
	CPPExprRefI initExpr;
	CPPTypeRefI newType;
	Tracer tracer(this, "expr_new");
	int _success = 0;
	;  
	_match(TOK_NEW);
		consume();
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_LPAREN) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					int _success = 0;
					_match(TOK_LPAREN);
										consume();
					  placementExpr   = expression_list();

					_match(TOK_RPAREN);
										consume();
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
			{ struct _rv57 _trv; _trv = expr_new_type_id();

			newType = _trv.cppType; arraySizeExpr   = _trv.exprArraySize; }
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_LPAREN) ) {
			_match(TOK_LPAREN);
						consume();
			  newType   = type_name();

			_match(TOK_RPAREN);
						consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err48);
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_LPAREN)&&(!(((LA(1)==TOK_LPAREN)))||(1)) ) {
			if (!(!(((LA(1)==TOK_LPAREN)))||(1))) {fail_predicate("  1");}
			  initExpr   = expr_new_initializer();

			_success = 1;
		}
	}
	_retv = MakeExprNew(placementExpr, newType, arraySizeExpr, initExpr, LT(1));   
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_new_initializer(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	Tracer tracer(this, "expr_new_initializer");
	int _success = 0;
	_match(TOK_LPAREN);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
		LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			  _retv   = expression_list();

			_success = 1;
		}
	}
	_match(TOK_RPAREN);
		consume();
	_success = 1;
	return _retv;
}

CPPParser::_rv57
CPPParser::expr_new_type_id(void)
{
	struct _rv57 _retv;
	zzRULE;
	
	CPPConst::StorageClass sc;
	CPPConst::DeclModifier dm;
	ANTLRTokenPtr errTok = LT(1);
	Tracer tracer(this, "expr_new_type_id");
	int _success = 0;
	;  
	{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  CPPConst::scNONE, CPPConst::dmNONE  );

	_retv.cppType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
	
	if (sc != CPPConst::scNONE)
	{
		ReportError("Storage class not allowed for new type id", errTok);
	}
	if (dm != CPPConst::dmNONE)
	{
		ReportError("Declaration modifier not allowed for new type id", errTok);
	}
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || LA(1)==TOK_ID)&&(!(((
			LA(1)==TOK_AMPERSAND || LA(1)==TOK_STAR)))||(1))))
				break;
			int _success = 0;
			if (!(!(((LA(1)==TOK_AMPERSAND || LA(1)==TOK_STAR)))||(1))) {fail_predicate("  1");}
			  _retv.cppType   = declarator_ptr(  _retv.cppType  );

			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_LSQUARE) ) {
			_match(TOK_LSQUARE);
			
			errTok = LT(1);   
			consume();
			{
				int _success = 0;
				if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
				LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
				LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
				LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
				LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
				LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
				LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
				LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
				LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
				LA(1)==TOK_CHARACTER) ) {
					  _retv.exprArraySize   = expression();

					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_RSQUARE) ) {
					_retv.cppType = LookupArrayOfType(_retv.cppType, CPPExprRefI(), errTok);   
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err49);
				}
			}
			_match(TOK_RSQUARE);
						consume();
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_LSQUARE)))
						break;
					int _success = 0;
					_match(TOK_LSQUARE);
					
					
					errTok = LT(1); 
					CPPExprRefI exprDimension;
					consume();
					  exprDimension   = expr_constant();

					_match(TOK_RSQUARE);
					
					_retv.cppType = LookupArrayOfType(_retv.cppType, exprDimension, errTok);   
					consume();
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_pm(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_pm");
	int _success = 0;
	;  
	  _retv   = expr_cast();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_DOTMBR || LA(1)==TOK_POINTERTOMBR)))
				break;
			int _success = 0;
			_setmatch(PM_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_cast();

			_retv = MakeExprBinary(_retv, expr2,  tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_postfix(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr ct=NULL;
	;  
	Tracer tracer(this, "expr_postfix");
	int _success = 0;
	;  
	{
		ANTLRParserState parserState;
		int _marker = 0;
		;  
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || 
		LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				CPPTypeRefI castType;   
				{
					int _success = 0;
					  castType   = simple_type_specifier();

					CommitGuess();   
					_match(TOK_LPAREN);
										consume();
					{
						int _success = 0;
						if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
						LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
						LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
						LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
						LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
						LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
						LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
						LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
						LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
						LA(1)==TOK_CHARACTER) ) {
							  _retv   = expression_list();

							_success = 1;
						}
					}
					_match(TOK_RPAREN);
										consume();
					_success = 1;
				}
				_retv = MakeExprFunctionLikeCast(castType, _retv);   
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_BOOLFALSE || 
		LA(1)==TOK_BOOLTRUE || LA(1)==TOK_OPERATOR || LA(1)==TOK_THIS || LA(1)==TOK_TYPENAME || LA(1)==TOK_ID || 
		LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || 
		LA(1)==TOK_STRING || LA(1)==TOK_CHARACTER) ) {
			  _retv   = expr_primary();

			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_CONST_CAST || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_STATIC_CAST) ) {
			CPPTypeRefI castType;   
			_setmatch(CAST_TOKCLASS_set);
			
			ct = (ANTLRTokenPtr)LT(1);
			consume();
			_match(TOK_LESSTHAN);
						consume();
			  castType   = type_name();

			_match(TOK_GREATERTHAN);
						consume();
			_match(TOK_LPAREN);
						consume();
			  _retv   = expression();

			_match(TOK_RPAREN);
			
			
			// Create the appropriate cast expression
			_retv = MakeExprNewCast( ct->getType(), castType, _retv);
			consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err52);
		}
	}
	{
		while ( 1 ) {
			if ( !((
			LA(1)==TOK_DOT || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_PLUSPLUS || 
			LA(1)==TOK_POINTERTO)&&(!(((LA(1)==TOK_LPAREN)))||(1))))
				break;
			int _success = 0;
			if (!(!(((LA(1)==TOK_LPAREN)))||(1))) {fail_predicate("  1");}
			CPPExprRefI expr2;   
			{
				int _success = 0;
				if ((LA(1)==TOK_LSQUARE) ) {
					_match(TOK_LSQUARE);
										consume();
					  expr2   = expression();

					_match(TOK_RSQUARE);
					
					_retv = MakeExprArraySubscript(_retv, expr2);   
					consume();
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_LPAREN) ) {
					_match(TOK_LPAREN);
										consume();
					{
						int _success = 0;
						if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
						LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
						LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
						LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
						LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
						LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
						LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
						LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
						LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
						LA(1)==TOK_CHARACTER) ) {
							  expr2   = expression_list();

							_success = 1;
						}
					}
					_match(TOK_RPAREN);
					
					_retv = MakeExprFunctionCall(_retv, expr2);   
					consume();
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_DOT) ) {
					_match(TOK_DOT);
										consume();
					  expr2  = expr_id(  _retv  );

					_retv = MakeExprBinary(_retv, expr2, TOK_DOT);   
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_POINTERTO) ) {
					_match(TOK_POINTERTO);
										consume();
					  expr2  = expr_id(  _retv  );

					_retv = MakeExprBinary(_retv, expr2, TOK_POINTERTO);   
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_PLUSPLUS) ) {
					_match(TOK_PLUSPLUS);
					
					_retv = MakeExprPostop(_retv, TOK_PLUSPLUS);   
					consume();
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_MINUSMINUS) ) {
					_match(TOK_MINUSMINUS);
					
					_retv = MakeExprPostop(_retv, TOK_MINUSMINUS);   
					consume();
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err53);
				}
			}
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_primary(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "expr_primary");
	int _success = 0;
	if ((LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || 
	LA(1)==TOK_ID) ) {
		;  
		  _retv   = expr_id(  CPPExprRefI()  );

		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || 
	LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || LA(1)==TOK_CHARACTER) ) {
		  _retv   = expr_literal();

		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_THIS) ) {
		_match(TOK_THIS);
		
		_retv = MakeExprThis();   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_LPAREN) ) {
		_match(TOK_LPAREN);
				consume();
		  _retv   = expression();

		_match(TOK_RPAREN);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err54);
	}
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_relational(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_relational");
	int _success = 0;
	;  
	  _retv   = expr_shift();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LESSTHAN || 
			LA(1)==TOK_LESSTHANOREQUALTO)))
				break;
			int _success = 0;
			_setmatch(RELATIONAL_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_shift();

			_retv = MakeExprBinary(_retv, expr2, tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_shift(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_shift");
	int _success = 0;
	;  
	  _retv   = expr_additive();

	{
		CPPExprRefI expr2;   
		while ( 1 ) {
			if ( !((LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTRIGHT)))
				break;
			int _success = 0;
			_setmatch(SHIFT_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  expr2   = expr_additive();

			_retv = MakeExprBinary(_retv, expr2, tok->getType());   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  CPPExprRefI   
CPPParser::expr_unary(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr tok=NULL;
	;  
	Tracer tracer(this, "expr_unary");
	int _success = 0;
	;  
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || 
		LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || LA(1)==TOK_CONST_CAST || LA(1)==TOK_DOUBLE || 
		LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					int _success = 0;
					  _retv   = expr_postfix();

					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_NOT || 
		LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_STAR || LA(1)==TOK_TILDE) ) {
			_setmatch(UNARYOP_TOKCLASS_set);
			
			tok = (ANTLRTokenPtr)LT(1);
			consume();
			  _retv   = expr_cast();

			_retv = MakeExprUnary(_retv, tok->getType());   
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SIZEOF) ) {
			_match(TOK_SIZEOF);
						consume();
			{
				ANTLRParserState parserState;
				int _marker = 0;
				int _success = 0;
				if ((LA(1)==TOK_LPAREN) ) {
					try {
						saveState(&parserState);
						guessing = 1;
						_marker = MarkInputTokens();
						{
							CPPTypeRefI sizeofType;   
							int _success = 0;
							_match(TOK_LPAREN);
														consume();
							  sizeofType   = type_name();

							_match(TOK_RPAREN);
							
							_retv = MakeExprSizeofType(sizeofType);   
							consume();
							_success = 1;
						}
						_success = 1;
						UnmarkInputTokens(_marker);
						guessing = parserState.guessing;   // restore only the guessing state
					} catch(AParserEX&) {
						if (guessing) {
							_success = 0;
							RewindInputTokens(_marker);
							restoreState(&parserState);
						} else {
							// CommitGuess() was called -- treat as an error
							UnmarkInputTokens(_marker);
							guessing = parserState.guessing;
							throw;
						}
					}
				}
				if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
				LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
				LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
				LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
				LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
				LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
				LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
				LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
				LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
				LA(1)==TOK_CHARACTER) ) {
					  _retv   = expr_unary();

					_retv = MakeExprSizeofExpr(_retv);   
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err58);
				}
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_DELETE || LA(1)==TOK_NEW) ) {
			{
				bool global = false;   
				int _success = 0;
				{
					int _success = 0;
					if ((LA(1)==TOK_SCOPE) ) {
						_match(TOK_SCOPE);
						
						global = true;   
						consume();
						_success = 1;
					}
				}
				{
					int _success = 0;
					if ((LA(1)==TOK_NEW) ) {
						  _retv   = expr_new( global );

						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_DELETE) ) {
						  _retv   = expr_delete( global );

						_success = 1;
					}
					if (!_success) {
						fail_syntax(err59);
					}
				}
				_success = 1;
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err60);
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::generic_block(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "generic_block");
	int _success = 0;
	;  
	_match(TOK_LCURLY);
		consume();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || 
			LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || 
			LA(1)==TOK_COMMA || LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || 
			LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || 
			LA(1)==TOK_LCURLY || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || 
			LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || 
			LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || 
			LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || 
			LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
			LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
			LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
			LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
			LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
			LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
			LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
			LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
			LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
			LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER)))
				break;
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LESSTHAN || 
			LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || 
			LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || 
			LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || 
			LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || 
			LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || 
			LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || 
			LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || 
			LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || 
			LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || 
			LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
			LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || 
			LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || 
			LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
			LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || 
			LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || 
			LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || 
			LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
			LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
			LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
			LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
			LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || 
			LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || 
			LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || LA(1)==136 || LA(1)==137 || 
			LA(1)==138 || LA(1)==139 || LA(1)==140 || LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || 
			LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PNDDEFINE || 
			LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || 
			LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || 
			LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || 
			LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || 
			LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER) ) {
				_setmatch(CURLY_TOKCLASS_set);
								consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_LCURLY) ) {
				generic_block();
				_success = 1;
			}
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_match(TOK_RCURLY);
		consume();
	_success = 1;
	return;
}

  CPPExprRefI   
CPPParser::initializer(void)
{
	  CPPExprRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "initializer");
	int _success = 0;
	if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
	LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
	LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
	LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
	LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
	LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
	LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
	LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
	LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
	LA(1)==TOK_CHARACTER) ) {
		;  
		  _retv   = expr_assignment();

		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_LCURLY) ) {
		_match(TOK_LCURLY);
				consume();
		  _retv   = expression_list();

		_match(TOK_RCURLY);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err62);
	}
	return _retv;
}

void
CPPParser::linkage_specification(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "linkage_specification");
	int _success = 0;
	;  
	_match(TOK_EXTERN);
		consume();
	_match(TOK_STRING);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LCURLY) ) {
			_match(TOK_LCURLY);
						consume();
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || 
					LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || 
					LA(1)==TOK_COMMA || LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || 
					LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || 
					LA(1)==TOK_LCURLY || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || 
					LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || 
					LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || 
					LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || 
					LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
					LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
					LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
					LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
					LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
					LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
					LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
					LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
					LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
					LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
					LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
					LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
					LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
					LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
					LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
					LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
					LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
					LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
					LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
					LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
					LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
					LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
					LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
					LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
					LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
					LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER)))
						break;
					// try block for exception handling
					try {
						int _success = 0;
						{
							int _success = 0;
							if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
							LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
							LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
							LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
							LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
							LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
							LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
							LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
							LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
							LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA) ) {
								declaration_external();
								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
							LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
							LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
							LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
							LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
							LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
							LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
							LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || 
							LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || 
							LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || 
							LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || 
							LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || 
							LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || 
							LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || 
							LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || 
							LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || 
							LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || 
							LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || 
							LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || 
							LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || 
							LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
							LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
							LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
							LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || 
							LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || 
							LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || 
							LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || LA(1)==136 || 
							LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || LA(1)==TOK_SLCOMMENT || 
							LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
							LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || 
							LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || 
							LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || 
							LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || 
							LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER) ) {
								_setmatch(RCURLY_EOF_TOKCLASS_set);
								
								fail_syntax(TOK_SEMICOLON);  
								consume();
								_success = 1;
							}
							if (!_success) {
								fail_syntax(err64);
							}
						}
						_success = 1;
						if ( !_success ) break; /* implied exit branch */
					} catch(AParserEX& ex) {
						// catch phrase for exception handling
						if (guessing) {
							// Propagate the exception
							throw;
						} else {
							
							ReportExceptionError(ex);
							consume();
							consumeUntil(EXTERNAL_SYNC_TOKCLASS_set);
							if (set_el(LA(1), EXTERNAL_SYNC2_TOKCLASS_set))
							{
								consume();
							}
						}
					}
				}
			}
			_match(TOK_RCURLY);
						consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
		LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
		LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
		LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
		LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
		LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
		LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA) ) {
			declaration_external();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err65);
		}
	}
	_success = 1;
	return;
}

  CPPTypeRefI   
CPPParser::optor_conversion(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	
	CPPConst::StorageClass sc;
	CPPConst::DeclModifier dm;
	ANTLRTokenPtr errTok = LT(1);
	Tracer tracer(this, "optor_conversion");
	int _success = 0;
	;  
	{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  CPPConst::scNONE, CPPConst::dmNONE  );

	_retv = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
	
	// Disallow storage class of decl modifier
	if (sc != CPPConst::scNONE || dm != CPPConst::dmNONE)
	{
		ReportError("Storage class or declaration modifier not allowed in operator", errTok);
	}
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_SCOPE || 
			LA(1)==TOK_STAR || LA(1)==TOK_ID)&&(!(((LA(1)==TOK_AMPERSAND || LA(1)==TOK_STAR)))||(1))))
				break;
			int _success = 0;
			if (!(!(((LA(1)==TOK_AMPERSAND || 
			LA(1)==TOK_STAR)))||(1))) {fail_predicate("  1");}
			  _retv   = declarator_ptr(  _retv  );

			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

  JLStr   
CPPParser::optor_simple(void)
{
	  JLStr   	 _retv;
	zzRULE;
	ANTLRTokenPtr os=NULL;
	;  
	Tracer tracer(this, "optor_simple");
	int _success = 0;
	if ((LA(1)==TOK_NEW) ) {
		;  
		_match(TOK_NEW);
		
		_retv = " new";   
		consume();
		{
			int _success = 0;
			if ((LA(1)==TOK_LSQUARE)&&(!(((LA(1)==TOK_LSQUARE)))||(LT(2)->getType() == TOK_RSQUARE)) ) {
				if (!(!(((LA(1)==TOK_LSQUARE)))||(LT(2)->getType() == TOK_RSQUARE))) {fail_predicate("  LT(2)->getType() == TOK_RSQUARE");}
				_match(TOK_LSQUARE);
								consume();
				_match(TOK_RSQUARE);
				
				_retv = "[]";   
				consume();
				_success = 1;
			}
		}
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_DELETE) ) {
		_match(TOK_DELETE);
		
		_retv = " delete";   
		consume();
		{
			int _success = 0;
			if ((LA(1)==TOK_LSQUARE)&&(!(((LA(1)==TOK_LSQUARE)))||(LT(2)->getType() == TOK_RSQUARE)) ) {
				if (!(!(((LA(1)==TOK_LSQUARE)))||(LT(2)->getType() == TOK_RSQUARE))) {fail_predicate("  LT(2)->getType() == TOK_RSQUARE");}
				_match(TOK_LSQUARE);
								consume();
				_match(TOK_RSQUARE);
				
				_retv = "[]";   
				consume();
				_success = 1;
			}
		}
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_LPAREN) ) {
		_match(TOK_LPAREN);
				consume();
		_match(TOK_RPAREN);
		
		_retv = "()";   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_LSQUARE) ) {
		_match(TOK_LSQUARE);
				consume();
		_match(TOK_RSQUARE);
		
		_retv = "[]";   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
	LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
	LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || 
	LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || 
	LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || 
	LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || 
	LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || 
	LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL) ) {
		_setmatch(OPTOR_SIMPLE_TOKCLASS_set);
		
		os = (ANTLRTokenPtr)LT(1);

		_retv =  os->getText();   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err67);
	}
	return _retv;
}

CPPParser::_rv69
CPPParser::parameter_declaration(  CPPTypeRefI inputType  )
{
	struct _rv69 _retv;
	zzRULE;
	
	CPPTypeRefI argType; 
	CPPConst::StorageClass sc; 
	CPPConst::DeclModifier dm;
	CPPExprRefI initExpr;
	ANTLRTokenPtr tok = LT(1);
	_retv.outputType =  inputType; 
	Tracer tracer(this, "parameter_declaration");
	int _success = 0;
	;  
	{ struct _rv18 _trv; _trv = declaration_sc_or_dm_seq();

	sc = _trv.sc; dm   = _trv.dm; }
	{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  sc, dm  );

	argType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
	
	// Handle error for invalid storage class or decl-modifier
	if (
	(
	sc & 
	(
	CPPConst::scAUTO | CPPConst::scSTATIC | CPPConst::scEXTERN | 
	CPPConst::scTYPEDEF | CPPConst::scMSDLLImport | 
	CPPConst::scMSDLLExport | CPPConst::scMSBased
	)
	) != CPPConst::scNONE
	)
	{
		ReportError("Invalid storage class for function parameter", tok);
	}
	if (dm != CPPConst::dmNONE)
	{
		ReportError("Declaration modifier not allowed for function parameter", tok);
	}
	{ struct _rv27 _trv; _trv = declarator_opt_abstract(  argType  );

	_retv.argName = _trv.declName; argType   = _trv.outputType; }
	{
		int _success = 0;
		if ((LA(1)==TOK_ASSIGNEQUAL) ) {
			_match(TOK_ASSIGNEQUAL);
						consume();
			  initExpr   = expr_assignment();

			_success = 1;
		}
	}
	
	_retv.outputType = LookupFunctionArgType( inputType, argType, tok); 
	if (_retv.argName.length() != 0)
	{
		DeclareObjectOrTypedef(
		_retv.argName,
		argType,
		sc,
		CPPConst::dmNONE,
		initExpr,
		GetCurrentScope(),
		StrListRefI()
		);
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv70
CPPParser::parameter_declaration_list(  CPPTypeRefI inputType  )
{
	struct _rv70 _retv;
	zzRULE;
	
	JLStr argName;
	_retv.argNameList = MakeStrList(); 
	_retv.outputType =  inputType;
	Tracer tracer(this, "parameter_declaration_list");
	int _success = 0;
	;  
	{ struct _rv69 _trv; _trv = parameter_declaration(   inputType  );

	argName = _trv.argName; _retv.outputType   = _trv.outputType; }
	AddStrToList(_retv.argNameList, argName);   
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)&&(!(((LA(1)==TOK_COMMA)))||(LT(2)->getType() != TOK_ELLIPSIS))))
				break;
			int _success = 0;
			if (!(!(((LA(1)==TOK_COMMA)))||(LT(2)->getType() != TOK_ELLIPSIS))) {fail_predicate("  LT(2)->getType() != TOK_ELLIPSIS");}
			_match(TOK_COMMA);
						consume();
			{ struct _rv69 _trv; _trv = parameter_declaration(  _retv.outputType  );

			argName = _trv.argName; _retv.outputType   = _trv.outputType; }
			AddStrToList(_retv.argNameList, argName);   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv71
CPPParser::parameter_list(  CPPTypeRefI inputType  )
{
	struct _rv71 _retv;
	zzRULE;
	_retv.outputType =  inputType;   
	Tracer tracer(this, "parameter_list");
	int _success = 0;
	if ((LA(1)==TOK_SCOPE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
	LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
	LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
	LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
	LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
	LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
	LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
		;  
		{ struct _rv70 _trv; _trv = parameter_declaration_list(   inputType  );

		_retv.argNameList = _trv.argNameList; _retv.outputType   = _trv.outputType; }
		{
			int _success = 0;
			if ((LA(1)==TOK_COMMA || LA(1)==TOK_ELLIPSIS) ) {
				{
					int _success = 0;
					if ((LA(1)==TOK_COMMA) ) {
						_match(TOK_COMMA);
												consume();
						_success = 1;
					}
				}
				_match(TOK_ELLIPSIS);
				
				_retv.outputType = LookupFunctionEllipsesType(_retv.outputType);   
				consume();
				_success = 1;
			}
		}
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_ELLIPSIS) ) {
		_match(TOK_ELLIPSIS);
		
		_retv.outputType = LookupFunctionEllipsesType( inputType);   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err68);
	}
	return _retv;
}

CPPParser::_rv72
CPPParser::parameter_list_opt(  CPPTypeRefI inputType  )
{
	struct _rv72 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "parameter_list_opt");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_RPAREN || LA(1)==TOK_VOID)&&(!(((LA(1)==TOK_VOID)))||(LT(2)->getType() == TOK_RPAREN)) ) {
			if (!(!(((LA(1)==TOK_VOID)))||(LT(2)->getType() == TOK_RPAREN))) {fail_predicate("  LT(2)->getType() == TOK_RPAREN");}
			{
				int _success = 0;
				if ((LA(1)==TOK_VOID) ) {
					_match(TOK_VOID);
										consume();
					_success = 1;
				}
			}
			
			_retv.outputType =  inputType;
			_retv.argNameList = MakeStrList(); 
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_ELLIPSIS || LA(1)==TOK_SCOPE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
		LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || 
		LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
		LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
		LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
		LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			{ struct _rv71 _trv; _trv = parameter_list(   inputType  );

			_retv.argNameList = _trv.argNameList; _retv.outputType   = _trv.outputType; }
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err69);
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::pragma_line(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "pragma_line");
	int _success = 0;
	;  
	HandlePragma();   
	_match(TOK_PNDPRAGMA);
		consume();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || 
			LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || 
			LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || 
			LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || 
			LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || 
			LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || 
			LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || 
			LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || 
			LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
			LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || 
			LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
			LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || 
			LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || 
			LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || 
			LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
			LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || 
			LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || 
			LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || 
			LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
			LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || 
			LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || 
			LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || 
			LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || 
			LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
			LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || 
			LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || 
			LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || 
			LA(1)==TOK_FLOATTWO || LA(1)==135 || LA(1)==136 || LA(1)==137 || LA(1)==138 || 
			LA(1)==139 || LA(1)==140 || LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || 
			LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || 
			LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || 
			LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || 
			LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || 
			LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || 
			LA(1)==TOK_CHARACTER)))
				break;
			int _success = 0;
			_setmatch(err70);
						consume();
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_match(TOK_PRAGMA_END);
		consume();
	_success = 1;
	return;
}

CPPParser::_rv74
CPPParser::qualified_id(  bool allowType, bool allowCtor, bool allowAnyDtor  )
{
	struct _rv74 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	// In case of error, this will rollback scope modifications
	ScopePopper scopePopper(this); 
	Tracer tracer(this, "qualified_id");
	int _success = 0;
	;   
	{
		int _success = 0;
		if ((LA(1)==TOK_TYPENAME) ) {
			if (!(allowType)) {fail_predicate("  allowType");}
			_match(TOK_TYPENAME);
						consume();
			_success = 1;
		}
	}
	  _retv.usedInnerTemplateParms   = scope_override();

	{
		bool isDtor = false;  
		int _success = 0;
		if ((LA(1)==TOK_TILDE || LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				if ((LA(1)==TOK_TILDE) ) {
					_match(TOK_TILDE);
					
					isDtor = true;   
					consume();
					_success = 1;
				}
			}
			_match(TOK_ID);
			
			id = (ANTLRTokenPtr)LT(1);
			consume();
			{
				int _success = 0;
				if ((LA(1)==TOK_LESSTHAN)&&(!(((LA(1)==TOK_LESSTHAN)))||(IsTemplateName( id->getText()))) ) {
					if (!(!(((LA(1)==TOK_LESSTHAN)))||(IsTemplateName( id->getText())))) {fail_predicate("  IsTemplateName( id->getText())");}
					
					ScopeSaver scopeSaver(this, scopePopper.Get());
					CPPTypeRefI specializationType; 
					bool tmpBool;
					{ struct _rv102 _trv; _trv = template_specialization(   id->getText(), scopePopper.Get(),  id  );

					_retv.name = _trv.specializationName; specializationType = _trv.specializationType; tmpBool   = _trv.usedInnerTemplateParms; }
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
				LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
				LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
				LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
				LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
				LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOTEQUAL || 
				LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || 
				LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || 
				LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || 
				LA(1)==TOK_STAR || LA(1)==TOK_TIMESEQUAL) ) {
					_retv.name =  id->getText();   
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err71);
				}
			}
			
			bool qualifiedIdValid = 
			(!isDtor && allowType && IsTypeName(_retv.name)) ||
			(isDtor && (allowAnyDtor || IsEnclosingClassName(_retv.name))) ||
			((isDtor || allowCtor) && IsEnclosingClassName(_retv.name)) ||
			(!isDtor && !IsScopeName(_retv.name));
			if (!(qualifiedIdValid )) {fail_predicate("   qualifiedIdValid ");}
			
			if (isDtor) {
				_retv.name = "~" + _retv.name;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_OPERATOR) ) {
			_match(TOK_OPERATOR);
						consume();
			{
				;  
				int _success = 0;
				if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
				LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
				LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || 
				LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
				LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
				LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
				LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || 
				LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_DELETE || 
				LA(1)==TOK_NEW) ) {
					JLStr tmpName;   
					  tmpName   = optor_simple();

					_retv.name = "operator" + tmpName;   
					_success = 1;
				}
				if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
				LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
				LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
				LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
				LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
					{
						
						ScopeSaver scopeSaver(this, scopePopper.Get());
						scopePopper.Restore();
						CPPTypeRefI conversionType; 
						int _success = 0;
						  conversionType   = optor_conversion();

						_retv.name = "operator " + FormatTypeName(conversionType);   
						_success = 1;
					}
					_success = 1;
				}
				if (!_success) {
					fail_syntax(err72);
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err73);
		}
	}
	scopePopper.Commit();   
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::qualified_type(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	ScopePopper scopePopper(this); 
	bool hasTypenameKeyword = false;
	bool dummy;
	Tracer tracer(this, "qualified_type");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_TYPENAME) ) {
			_match(TOK_TYPENAME);
			
			hasTypenameKeyword = true;   
			consume();
			_success = 1;
		}
	}
	  dummy   = scope_override();

	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);

	if (!(hasTypenameKeyword || IsTypeName( id->getText()) )) {fail_predicate("   hasTypenameKeyword || IsTypeName( id->getText()) ");}
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LESSTHAN)&&(!(((LA(1)==TOK_LESSTHAN)))||(1)) ) {
			if (!(!(((LA(1)==TOK_LESSTHAN)))||(1))) {fail_predicate("  1");}
			{
				
				JLStr specializationName; 
				bool tmpBool;
				int _success = 0;
				{ struct _rv102 _trv; _trv = template_specialization(   id->getText(), scopePopper.Get(),  id  );

				specializationName = _trv.specializationName; _retv = _trv.specializationType; tmpBool   = _trv.usedInnerTemplateParms; }
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOTEQUAL || 
		LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || 
		LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || 
		LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || 
		LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_AUTO || 
		LA(1)==TOK_CONST || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
		LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_STATIC || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOLATILE || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			
			// Lookup the type corresponding to the name
			// This will work even if IsTypeName() returned false,
			// as long as the scope override is a special template scope.
			_retv = LookupType( id->getText(),  id);
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err74);
		}
	}
	_success = 1;
	return _retv;
}

  bool   
CPPParser::scope_override(void)
{
	  bool   	 _retv;
	zzRULE;
	
	CPPScopeState scopeState = SaveScope();
	_retv = false;
	Tracer tracer(this, "scope_override");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE) ) {
			_match(TOK_SCOPE);
			
			EnterResolvedGlobalScope();   
			consume();
			_success = 1;
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_ID)&&(!(((LA(1)==TOK_ID)))||(IsScopeSegment(1, true) )) ) {
			if (!(IsScopeSegment(1, true) )) {fail_predicate("   IsScopeSegment(1, true) ");}
			  _retv   = scope_segment_list(  scopeState, true  );

			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv77
CPPParser::scope_segment(  CPPScopeState scopeState, bool isTemplate, bool isVerified  )
{
	struct _rv77 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	JLStr scopeName;  
	Tracer tracer(this, "scope_segment");
	int _success = 0;
	;  
	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LESSTHAN) ) {
			{
				int _success = 0;
				if (!(isTemplate || IsTemplateName( id->getText()) )) {fail_predicate("   isTemplate || IsTemplateName( id->getText()) ");}
				if (!(isVerified || NestedBracketsAreFollowedByScope() )) {fail_predicate("   isVerified || NestedBracketsAreFollowedByScope() ");}
				{ struct _rv102 _trv; _trv = template_specialization(   id->getText(), scopeState,  id  );

				scopeName = _trv.specializationName; _retv.classType = _trv.specializationType; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
				_match(TOK_SCOPE);
								consume();
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE) ) {
			_match(TOK_SCOPE);
			
			scopeName =  id->getText();   
			consume();
			
			if (!IsNamespaceName(scopeName))
			{
				// Even though this may find a non-class type, it is OK
				// because the scope entry will fail and reset $classType.
				_retv.classType = LookupType(scopeName,  id);
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err75);
		}
	}
	
	// Find the scope to enter
	CPPScopeRefI scope = LookupScope(scopeName,  id);
	// Pop the scope stack and enter the new scope
	RestoreScope(scopeState);
	EnterScope(scope, true);
	_success = 1;
	return _retv;
}

  bool   
CPPParser::scope_segment_list(  CPPScopeState scopeState, bool isVerified  )
{
	  bool   	 _retv;
	zzRULE;
	
	ScopePopper scopePopper(this);
	CPPTypeRefI tmpType;
	Tracer tracer(this, "scope_segment_list");
	int _success = 0;
	;  
	{ struct _rv77 _trv; _trv = scope_segment(  scopeState, false, isVerified  );

	tmpType = _trv.classType; _retv   = _trv.usedInnerTemplateParms; }
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_TEMPLATE || LA(1)==TOK_ID)&&(!(((LA(1)==TOK_TEMPLATE || 
			LA(1)==TOK_ID)))||(IsScopeSegment(1, true) ))))
				break;
			int _success = 0;
			if (!(IsScopeSegment(1, true) )) {fail_predicate("   IsScopeSegment(1, true) ");}
			
			bool isTemplate = false; 
			bool tmpUsedInnerTemplateParms;
			{
				int _success = 0;
				if ((LA(1)==TOK_TEMPLATE) ) {
					_match(TOK_TEMPLATE);
					
					isTemplate = true;  
					consume();
					_success = 1;
				}
			}
			{ struct _rv77 _trv; _trv = scope_segment(  scopeState, isTemplate, true  );

			tmpType = _trv.classType; tmpUsedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
			_retv |= tmpUsedInnerTemplateParms;   
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	scopePopper.Commit();  
	_success = 1;
	return _retv;
}

  CPPTypeRefI   
CPPParser::simple_type_specifier(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	;  
	Tracer tracer(this, "simple_type_specifier");
	int _success = 0;
	;  
	{
		;  
		int _success = 0;
		if ((LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_DOUBLE || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || 
		LA(1)==TOK_MSEXT_INT64) ) {
			
			CPPConst::TypeSpecifier ts; 
			ANTLRTokenPtr errTok = LT(1);
			  ts   = builtin_type_specifier();

			_retv = LookupBuiltinType(ts, errTok);   
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_TYPENAME || LA(1)==TOK_ID) ) {
			  _retv   = qualified_type();

			_success = 1;
		}
		if (!_success) {
			fail_syntax(err76);
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::statement(void)
{
	zzRULE;
	ANTLRParserState parserState;
	int _marker = 0;
	;  
	Tracer tracer(this, "statement");
	int _success = 0;
	if ((LA(1)==TOK_LCURLY) ) {
		;  
		statement_compound();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_IF || LA(1)==TOK_SWITCH) ) {
		statement_selection();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_DO || LA(1)==TOK_FOR || LA(1)==TOK_WHILE) ) {
		statement_iteration();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_BREAK || LA(1)==TOK_CONTINUE || LA(1)==TOK_GOTO || LA(1)==TOK_RETURN) ) {
		statement_jump();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_TRY) ) {
		statement_try_block();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_THROW) ) {
		statement_throw();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_ASM || LA(1)==TOK_MSEXT_ASM) ) {
		statement_asm();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_CASE || LA(1)==TOK_DEFAULT || LA(1)==TOK_ID)&&(!(((LA(1)==TOK_ID)))||(LT(2)->getType() == TOK_COLON)) ) {
		if (!(!(((
		LA(1)==TOK_ID)))||(LT(2)->getType() == TOK_COLON))) {fail_predicate("  LT(2)->getType() == TOK_COLON");}
		statement_labeled();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
	LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
	LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
	LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
	LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
	LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
	LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
		try {
			saveState(&parserState);
			guessing = 1;
			_marker = MarkInputTokens();
			{
				int _success = 0;
				statement_declaration();
				_success = 1;
			}
			_success = 1;
			UnmarkInputTokens(_marker);
			guessing = parserState.guessing;   // restore only the guessing state
		} catch(AParserEX&) {
			if (guessing) {
				_success = 0;
				RewindInputTokens(_marker);
				restoreState(&parserState);
			} else {
				// CommitGuess() was called -- treat as an error
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;
				throw;
			}
		}
	}
	if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
	LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
	LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
	LA(1)==TOK_CHAR || LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
	LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
	LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || 
	LA(1)==TOK_THIS || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || 
	LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || 
	LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || 
	LA(1)==TOK_STRING || LA(1)==TOK_CHARACTER) ) {
		{
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
			LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
			LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
			LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
			LA(1)==TOK_CHARACTER) ) {
				expression();
				_success = 1;
			}
		}
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err77);
	}
	return;
}

void
CPPParser::statement_asm(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_asm");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_ASM) ) {
			_match(TOK_ASM);
						consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_MSEXT_ASM) ) {
			_match(TOK_MSEXT_ASM);
						consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err78);
		}
	}
	{
		int _success = 0;
		if ((LA(1)==TOK_LCURLY)&&(!(((LA(1)==TOK_LCURLY)))||(1)) ) {
			if (!(!(((LA(1)==TOK_LCURLY)))||(1))) {fail_predicate("  1");}
			_match(TOK_LCURLY);
						consume();
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AMPERSAND || 
					LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || 
					LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || 
					LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || 
					LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || 
					LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || 
					LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || 
					LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || 
					LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
					LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || 
					LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
					LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || 
					LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || 
					LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || 
					LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
					LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || 
					LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || 
					LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || 
					LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
					LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || 
					LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || 
					LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || 
					LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || 
					LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
					LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || 
					LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || 
					LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || 
					LA(1)==TOK_FLOATTWO || LA(1)==135 || LA(1)==136 || LA(1)==137 || LA(1)==138 || 
					LA(1)==139 || LA(1)==140 || LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || 
					LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || 
					LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || 
					LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || 
					LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || 
					LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || 
					LA(1)==169 || LA(1)==TOK_CHARACTER)))
						break;
					int _success = 0;
					_setmatch(err79);
										consume();
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_match(TOK_RCURLY);
						consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
		LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
		LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
		LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
		LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
		LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER) ) {
			{
				while ( 1 ) {
					if ( !((
					LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || 
					LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_COLON || 
					LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || 
					LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || 
					LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || 
					LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || 
					LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || 
					LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RPAREN || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SHIFTLEFT || 
					LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || 
					LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || 
					LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || 
					LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || 
					LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
					LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || 
					LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || 
					LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || 
					LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || 
					LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || 
					LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || 
					LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || 
					LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || 
					LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || 
					LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
					LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || 
					LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || 
					LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || 
					LA(1)==135 || LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || 
					LA(1)==140 || LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || 
					LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || 
					LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || 
					LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || 
					LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || 
					LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || 
					LA(1)==TOK_CHARACTER)))
						break;
					int _success = 0;
					_setmatch(CURLY_SEMICOLON_TOKCLASS_set);
										consume();
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err81);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::statement_catch(void)
{
	zzRULE;
	Tracer tracer(this, "statement_catch");
	int _success = 0;
	_match(TOK_CATCH);
		consume();
	_match(TOK_LPAREN);
		consume();
	statement_exception_declaration();
	_match(TOK_RPAREN);
		consume();
	statement_compound();
	_success = 1;
	return;
}

void
CPPParser::statement_compound(void)
{
	zzRULE;
	
	ScopePopper scopePopper(this);
	EnterLocalScope();
	Tracer tracer(this, "statement_compound");
	int _success = 0;
	;  
	_match(TOK_LCURLY);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LCURLY || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSMINUS || LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || 
		LA(1)==TOK_SEMICOLON || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || 
		LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || 
		LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || 
		LA(1)==TOK_DEFAULT || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_THIS || LA(1)==TOK_THROW || 
		LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
		LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			statement_list();
			_success = 1;
		}
	}
	_match(TOK_RCURLY);
		consume();
	_success = 1;
	return;
}

void
CPPParser::statement_declaration(void)
{
	zzRULE;
	
	CPPTypeRefI cppType;
	CPPConst::StorageClass sc;
	CPPConst::DeclModifier dm;
	ScopePopper scopePopper(this);
	Tracer tracer(this, "statement_declaration");
	int _success = 0;
	;   
	{ struct _rv18 _trv; _trv = declaration_sc_or_dm_seq();

	sc = _trv.sc; dm   = _trv.dm; }
	{ struct _rv19 _trv; _trv = declaration_specifiers(  sc, dm  );

	cppType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || 
		LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
			declarator_init_list(  cppType, sc, dm  );
			_success = 1;
		}
	}
	_match(TOK_SEMICOLON);
		consume();
	_success = 1;
	return;
}

void
CPPParser::statement_exception_declaration(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_exception_declaration");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
		LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
		LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			parameter_declaration_list(  CPPTypeRefI()  );
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_ELLIPSIS) ) {
			_match(TOK_ELLIPSIS);
						consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err82);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::statement_iteration(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_iteration");
	int _success = 0;
	if ((LA(1)==TOK_WHILE) ) {
		;  
		_match(TOK_WHILE);
				consume();
		_match(TOK_LPAREN);
				consume();
		expression();
		_match(TOK_RPAREN);
				consume();
		statement();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_DO) ) {
		_match(TOK_DO);
				consume();
		statement();
		_match(TOK_WHILE);
				consume();
		_match(TOK_LPAREN);
				consume();
		expression();
		_match(TOK_RPAREN);
				consume();
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_FOR) ) {
		_match(TOK_FOR);
				consume();
		_match(TOK_LPAREN);
				consume();
		{
			ANTLRParserState parserState;
			int _marker = 0;
			int _success = 0;
			if ((LA(1)==TOK_SCOPE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
			LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
			LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
			LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
				try {
					saveState(&parserState);
					guessing = 1;
					_marker = MarkInputTokens();
					{
						int _success = 0;
						statement_declaration();
						_success = 1;
					}
					_success = 1;
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;   // restore only the guessing state
				} catch(AParserEX&) {
					if (guessing) {
						_success = 0;
						RewindInputTokens(_marker);
						restoreState(&parserState);
					} else {
						// CommitGuess() was called -- treat as an error
						UnmarkInputTokens(_marker);
						guessing = parserState.guessing;
						throw;
					}
				}
			}
			if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
			LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
			LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_CHAR || LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
			LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || 
			LA(1)==TOK_THIS || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || 
			LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || 
			LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || 
			LA(1)==TOK_STRING || LA(1)==TOK_CHARACTER) ) {
				{
					int _success = 0;
					if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
					LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
					LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
					LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
					LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
					LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
					LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
					LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
					LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
					LA(1)==TOK_CHARACTER) ) {
						expression();
						_success = 1;
					}
				}
				_match(TOK_SEMICOLON);
								consume();
				_success = 1;
			}
			if (!_success) {
				fail_syntax(err83);
			}
		}
		{
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
			LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
			LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
			LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
			LA(1)==TOK_CHARACTER) ) {
				expression();
				_success = 1;
			}
		}
		_match(TOK_SEMICOLON);
				consume();
		{
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
			LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
			LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
			LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
			LA(1)==TOK_CHARACTER) ) {
				expression();
				_success = 1;
			}
		}
		_match(TOK_RPAREN);
				consume();
		statement();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err84);
	}
	return;
}

void
CPPParser::statement_jump(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_jump");
	int _success = 0;
	if ((LA(1)==TOK_GOTO) ) {
		;  
		_match(TOK_GOTO);
				consume();
		_match(TOK_ID);
				consume();
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_CONTINUE) ) {
		_match(TOK_CONTINUE);
				consume();
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_BREAK) ) {
		_match(TOK_BREAK);
				consume();
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_RETURN) ) {
		_match(TOK_RETURN);
				consume();
		{
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
			LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
			LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
			LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
			LA(1)==TOK_CHARACTER) ) {
				expression();
				_success = 1;
			}
		}
		_match(TOK_SEMICOLON);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err85);
	}
	return;
}

void
CPPParser::statement_labeled(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_labeled");
	int _success = 0;
	if ((LA(1)==TOK_ID) ) {
		;  
		_match(TOK_ID);
				consume();
		_match(TOK_COLON);
				consume();
		statement();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_CASE) ) {
		_match(TOK_CASE);
				consume();
		expr_constant();
		_match(TOK_COLON);
				consume();
		statement();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_DEFAULT) ) {
		_match(TOK_DEFAULT);
				consume();
		_match(TOK_COLON);
				consume();
		statement();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err86);
	}
	return;
}

void
CPPParser::statement_list(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_list");
	int _success = 0;
	;  
	{
		int zzcnt=1;
		do {
			// try block for exception handling
			try {
				int _success = 0;
				if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LCURLY || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || 
				LA(1)==TOK_MINUSMINUS || LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || 
				LA(1)==TOK_SEMICOLON || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || 
				LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || 
				LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || 
				LA(1)==TOK_DEFAULT || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
				LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
				LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
				LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
				LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
				LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_THIS || LA(1)==TOK_THROW || 
				LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
				LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || 
				LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
				LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
				LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
				LA(1)==TOK_CHARACTER) ) {
					statement();
					_success = 1;
				}
				if ( !_success && zzcnt>1 ) break; /* implied exit branch */
				if (!_success) {
					fail_syntax(err87);
				}
				zzcnt++;
			} catch(AParserEX& ex) {
				// catch phrase for exception handling
				if (guessing) {
					// Propagate the exception
					throw;
				} else {
					
					ReportExceptionError(ex);
					consume();
					consumeUntil(STATEMENT_SYNC_TOKCLASS_set);
					
         // This is a hack to avoid infinite loop -- should do better
					if (LA(1) == TOK_Eof) throw;
				}
			}
		} while ( 1 );
	}
	_success = 1;
	return;
}

void
CPPParser::statement_selection(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_selection");
	int _success = 0;
	if ((LA(1)==TOK_IF) ) {
		;  
		_match(TOK_IF);
				consume();
		_match(TOK_LPAREN);
				consume();
		expression();
		_match(TOK_RPAREN);
				consume();
		statement();
		{
			int _success = 0;
			if ((LA(1)==TOK_ELSE) ) {
				_match(TOK_ELSE);
								consume();
				statement();
				_success = 1;
			}
		}
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_SWITCH) ) {
		_match(TOK_SWITCH);
				consume();
		_match(TOK_LPAREN);
				consume();
		expression();
		_match(TOK_RPAREN);
				consume();
		statement();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err88);
	}
	return;
}

void
CPPParser::statement_throw(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_throw");
	int _success = 0;
	;  
	_match(TOK_THROW);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
		LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
		LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
		LA(1)==TOK_CHARACTER) ) {
			expr_assignment();
			_success = 1;
		}
	}
	_match(TOK_SEMICOLON);
		consume();
	_success = 1;
	return;
}

void
CPPParser::statement_try_block(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "statement_try_block");
	int _success = 0;
	;  
	_match(TOK_TRY);
		consume();
	statement_compound();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_CATCH)))
				break;
			int _success = 0;
			statement_catch();
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

 CPPConst::StorageClass  
CPPParser::storage_class_specifier(void)
{
	 CPPConst::StorageClass  	 _retv;
	zzRULE;
	ANTLRTokenPtr declSpecId=NULL;
	;  
	Tracer tracer(this, "storage_class_specifier");
	int _success = 0;
	if ((LA(1)==TOK_AUTO) ) {
		;  
		_match(TOK_AUTO);
		
		_retv = CPPConst::scAUTO;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_REGISTER) ) {
		_match(TOK_REGISTER);
		
		_retv = CPPConst::scREGISTER;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_STATIC) ) {
		_match(TOK_STATIC);
		
		_retv = CPPConst::scSTATIC;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_EXTERN) ) {
		_match(TOK_EXTERN);
		
		_retv = CPPConst::scEXTERN;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_TYPEDEF) ) {
		_match(TOK_TYPEDEF);
		
		_retv = CPPConst::scTYPEDEF;  
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_MSEXT_BASED) ) {
		_match(TOK_MSEXT_BASED);
				consume();
		_match(TOK_LPAREN);
				consume();
		_match(TOK_ID);
				consume();
		_match(TOK_RPAREN);
		
		_retv = CPPConst::scMSBased;   
		consume();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_MSEXT_DECLSPEC) ) {
		_match(TOK_MSEXT_DECLSPEC);
				consume();
		_match(TOK_LPAREN);
				consume();
		_match(TOK_ID);
		
		declSpecId = (ANTLRTokenPtr)LT(1);

		
		if (strcmp( declSpecId->getText(), "dllimport") == 0)
		{
			_retv = CPPConst::scMSDLLImport;
		} else if (strcmp( declSpecId->getText(), "dllexport") == 0)
		{
			_retv = CPPConst::scMSDLLExport;
		} else {
			_retv = CPPConst::scNONE;
		}
		consume();
		_match(TOK_RPAREN);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err89);
	}
	return _retv;
}

CPPParser::_rv94
CPPParser::template_argument(void)
{
	struct _rv94 _retv;
	zzRULE;
	ANTLRParserState parserState;
	int _marker = 0;
	_retv.usedInnerTemplateParms = false;  
	Tracer tracer(this, "template_argument");
	int _success = 0;
	if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
	LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
	LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
	LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
		try {
			saveState(&parserState);
			guessing = 1;
			_marker = MarkInputTokens();
			;  
			{
				CPPTypeRefI type;   
				int _success = 0;
				  type   = type_name();

				
				// Check to see if the type argument uses a template placeholder
				// from the innermost template head.
				_retv.usedInnerTemplateParms = TypeUsesInnerTemplateParms(type);
				
            // Create the template argument
				_retv.argRef = MakeTemplateArgumentType(type); 
				_success = 1;
			}
			_success = 1;
			UnmarkInputTokens(_marker);
			guessing = parserState.guessing;   // restore only the guessing state
		} catch(AParserEX&) {
			if (guessing) {
				_success = 0;
				RewindInputTokens(_marker);
				restoreState(&parserState);
			} else {
				// CommitGuess() was called -- treat as an error
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;
				throw;
			}
		}
	}
	if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSMINUS || 
	LA(1)==TOK_NOT || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
	LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_CHAR || 
	LA(1)==TOK_CONST_CAST || LA(1)==TOK_DELETE || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_FLOAT || 
	LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_REINTERPRET_CAST || 
	LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_THIS || 
	LA(1)==TOK_TYPENAME || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
	LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
	LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==TOK_STRING || 
	LA(1)==TOK_CHARACTER) ) {
		{
			CPPExprRefI expr;   
			int _success = 0;
			  expr   = expr_shift();

			_retv.argRef = MakeTemplateArgumentValue(expr);   
			_success = 1;
		}
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err90);
	}
	return _retv;
}

CPPParser::_rv95
CPPParser::template_argument_list(void)
{
	struct _rv95 _retv;
	zzRULE;
	
	TemplateArgumentRefI argRef;
	_retv.argList = MakeTemplateArgumentList(); 
	Tracer tracer(this, "template_argument_list");
	int _success = 0;
	;  
	{ struct _rv94 _trv; _trv = template_argument();

	argRef = _trv.argRef; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
	AddTemplateArgumentToList(_retv.argList, argRef);   
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
			
			bool tmpUsedInnerTemplateParms;   
			consume();
			{ struct _rv94 _trv; _trv = template_argument();

			argRef = _trv.argRef; tmpUsedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
			
			AddTemplateArgumentToList(_retv.argList, argRef); 
			_retv.usedInnerTemplateParms |= tmpUsedInnerTemplateParms;
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return _retv;
}

void
CPPParser::template_declaration(  CPPScopeRefI preTemplateScope, bool memberDecl  )
{
	zzRULE;
	
	ScopePopper scopePopper(this);
	TemplateParameterListRefI templateParameters;
	CPPDeclRefI rawDecl;
	Tracer tracer(this, "template_declaration");
	int _success = 0;
	;  
	  templateParameters   = template_head();

	
	// Remember the template parameter scope
	ScopePopper templateScopePopper(this);
	CPPScopeRefI templateParameterScope = GetCurrentScope(); 
	
      // Bump template level; restore it upon return/exception
	TemplateLevelIncrementer templateLevelIncrementer(this);
	{
		ANTLRParserState parserState;
		int _marker = 0;
		int _success = 0;
		if ((LA(1)==TOK_TEMPLATE) ) {
			template_declaration(  preTemplateScope, memberDecl  );
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_CLASS || LA(1)==TOK_STRUCT || LA(1)==TOK_UNION) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				{
					int _success = 0;
					template_declaration_class(  
               preTemplateScope, 
               templateParameters, 
               memberDecl, 
               templateScopePopper.Get() 
             );
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
		LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || 
		LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STRUCT || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
		LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || 
		LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
		LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			template_declaration_function_or_data(  
            preTemplateScope, 
            templateParameters, 
            memberDecl, 
            templateScopePopper.Get(),
            templateParameterScope
          );
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err91);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::template_declaration_class(  
   CPPScopeRefI preTemplateScope, 
   TemplateParameterListRefI templateParameters,
   bool memberDecl,
   CPPScopeState templateScopeState
 )
{
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	ANTLRTokenPtr errTok = LT(1);
	CPPTypeRefI classType;
	CPPDeclRefI templateDecl;
	CPPTypeRefI templateType;
	JLStr templateName;
	CPPConst::TypeSpecifier ts;
	// Create a token collector to grab the body of the declaration.
	TokenCollector tokenCollector(this); 
	bool usedInnerTemplateParms;
	TemplateArgumentListRefI specializationArgList = MakeTemplateArgumentList();
	Tracer tracer(this, "template_declaration_class");
	int _success = 0;
	{
		int _success = 0;
		if ((LA(1)==TOK_STRUCT) ) {
			_match(TOK_STRUCT);
			
			ts = CPPConst::tsSTRUCT;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_UNION) ) {
			_match(TOK_UNION);
			
			ts = CPPConst::tsUNION;  
			consume();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_CLASS) ) {
			_match(TOK_CLASS);
			
			ts = CPPConst::tsCLASS;  
			consume();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err92);
		}
	}
	  usedInnerTemplateParms   = scope_override();

	
	CPPScopeRefI declContextScope;
	if ( templateScopeState != SaveScope())
	{
		declContextScope = GetCurrentScope(); 
		// Pop scope stack to process template specialization args
		RestoreScope( templateScopeState);
	} else {
		declContextScope =  preTemplateScope;
	}
	_match(TOK_ID);
	
	id = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_LESSTHAN) ) {
			_match(TOK_LESSTHAN);
			
			bool tmpBool;   
			consume();
			{ struct _rv95 _trv; _trv = template_argument_list();

			specializationArgList = _trv.argList; tmpBool   = _trv.usedInnerTemplateParms; }
			_match(TOK_GREATERTHAN);
						consume();
			_success = 1;
		}
	}
	{
		;  
		int _success = 0;
		if ((LA(1)==TOK_COLON || LA(1)==TOK_LCURLY) ) {
			
			// If we get here then we are committed to the class-template alt
			CommitGuess();
			
            bool classDefined;
			if (usedInnerTemplateParms)
			{
				// Plain class decl inside class template
				DefineClassType(
				id->getText(), 
				ts, 
				declContextScope,
				errTok,
				classType,
				templateDecl,
				templateName
				);
				classDefined = true;
			} else {
				// Define the class template.
				classDefined = DefineClassTemplateType(
				id->getText(), 
				ts, 
				declContextScope,
				templateParameters,
				specializationArgList,
				errTok,
				classType,
				templateType,
				templateDecl, 
				templateName
				);
			}
			{
				int _success = 0;
				if ((LA(1)==TOK_COLON) ) {
					base_clause(  classType  );
					_success = 1;
				}
			}
			
			// Enter the class template scope
			if (classDefined)
			{
				EnterClassScope(classType, false);
			}
			_match(TOK_LCURLY);
						consume();
			{
				while ( 1 ) {
					if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || 
					LA(1)==TOK_SEMICOLON || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || 
					LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || 
					LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || 
					LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
					LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STATIC || 
					LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || 
					LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
					LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
					LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_INLINE || 
					LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA)))
						break;
					// try block for exception handling
					try {
						int _success = 0;
						declaration_member();
						_success = 1;
						if ( !_success ) break; /* implied exit branch */
					} catch(AParserEX& ex) {
						// catch phrase for exception handling
						if (guessing) {
							// Propagate the exception
							throw;
						} else {
							
							ReportExceptionError(ex);
							consume();
							consumeUntil(MEMBER_SYNC_TOKCLASS_set);
						}
					}
				}
			}
			_match(TOK_RCURLY);
						consume();
			{
				int _success = 0;
				_match(TOK_SEMICOLON);
								consume();
				_success = 1;
			}
			
			// If the definition was successful, *and* it's a real template 
			// declaration, then set the template tokens.
			// TODO: we must set the token list for plain old class template members,
			if (classDefined && !usedInnerTemplateParms)
			{
			SetTokensInTemplateDeclaration(
			templateType, 
			templateParameters, 
			tokenCollector.Get()
			);
		}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SEMICOLON) ) {
			CommitGuess();  
			{
				int _success = 0;
				_match(TOK_SEMICOLON);
								consume();
				_success = 1;
			}
			
			// Declare the class template.  Note that the declaration scope
			// is always well-defined -- there is no searching the scope stack
			// for declarations in containing scopes.
			if (usedInnerTemplateParms)
			{
				// Plain old class decl inside class template (this is invalid I think)
				DeclareClassType(
				id->getText(), 
				ts, 
				declContextScope,
				errTok,
				templateType,
				templateDecl, 
				templateName
				);
			} else {
				// Declare class template
				DeclareClassTemplateType(
				id->getText(), 
				ts, 
				declContextScope,
				templateParameters,
				specializationArgList,
				errTok,
				classType,
				templateType,
				templateDecl, 
				templateName
				); 
				
               SetTokensInTemplateDeclaration(
				templateType, 
				templateParameters, 
				tokenCollector.Get()
				);
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err93);
		}
	}
	_success = 1;
	return;
}

void
CPPParser::template_declaration_function_or_data(  
   CPPScopeRefI preTemplateScope, 
   TemplateParameterListRefI templateParameters,
   bool memberDecl,
   CPPScopeState templateScopeState,
   CPPScopeRefI templateParameterScope
 )
{
	zzRULE;
	
	ANTLRTokenPtr errTok = LT(1);
	// Create a token collector to grab the body of the declaration.
	TokenCollector tokenCollector(this); 
	
      // Information used to make the declaration
	CPPConst::StorageClass sc;
	CPPConst::DeclModifier dm;
	JLStr declName;
	StrListRefI argNameList;
	CPPScopeRefI declScope;
	CPPScopeRefI argScope;
	CPPTypeRefI declType;
	CPPExprRefI initExpr;
	bool usedInnerTemplateParms;
	Tracer tracer(this, "template_declaration_function_or_data");
	int _success = 0;
	{ struct _rv18 _trv; _trv = declaration_sc_or_dm_seq();

	sc = _trv.sc; dm   = _trv.dm; }
	{
		ANTLRParserState parserState;
		int _marker = 0;
		;  
		int _success = 0;
		if ((LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID)&&(!(((
		LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID)))||(!memberDecl)) ) {
			try {
				saveState(&parserState);
				guessing = 1;
				_marker = MarkInputTokens();
				if (!(!memberDecl)) {fail_predicate("  !memberDecl");}
				{
					int _success = 0;
					{ struct _rv9 _trv; _trv = ctor_declarator();

					declName = _trv.declName; argNameList = _trv.argNameList; declScope = _trv.declScope; argScope = _trv.argScope; declType = _trv.outputType; usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
					
					ScopePopper ctorScopePopper(this);
					if (declScope != GetCurrentScope())
					{
						EnterScopeContext(declScope, false);
					}
					// DWP says that ctor is not entered in the class scope under
					// any name that can be uttered.  So we use "$ctor" instead.
					declName = "$ctor";
					EnterScope(argScope, false);
					{
						int _success = 0;
						if ((LA(1)==TOK_COLON) ) {
							ctor_initializer();
							_success = 1;
						}
					}
					statement_compound();
					_success = 1;
				}
				_success = 1;
				UnmarkInputTokens(_marker);
				guessing = parserState.guessing;   // restore only the guessing state
			} catch(AParserEX&) {
				if (guessing) {
					_success = 0;
					RewindInputTokens(_marker);
					restoreState(&parserState);
				} else {
					// CommitGuess() was called -- treat as an error
					UnmarkInputTokens(_marker);
					guessing = parserState.guessing;
					throw;
				}
			}
		}
		if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
		LA(1)==TOK_TILDE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || 
		LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || LA(1)==TOK_LONG || 
		LA(1)==TOK_OPERATOR || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
			{
				int _success = 0;
				{
					ANTLRParserState parserState;
					int _marker = 0;
					int _success = 0;
					if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
					LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
					LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
					LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
					LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
						try {
							saveState(&parserState);
							guessing = 1;
							_marker = MarkInputTokens();
							{
								int _success = 0;
								{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  sc, dm  );

								declType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
								_success = 1;
							}
							_success = 1;
							UnmarkInputTokens(_marker);
							guessing = parserState.guessing;   // restore only the guessing state
						} catch(AParserEX&) {
							if (guessing) {
								_success = 0;
								RewindInputTokens(_marker);
								restoreState(&parserState);
							} else {
								// CommitGuess() was called -- treat as an error
								UnmarkInputTokens(_marker);
								guessing = parserState.guessing;
								throw;
							}
						}
					}
					if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_STAR || 
					LA(1)==TOK_TILDE || LA(1)==TOK_OPERATOR || LA(1)==TOK_TYPENAME || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || 
					LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_ID) ) {
						declType = LookupVoidType();  
						_success = 1;
					}
					if (!_success) {
						fail_syntax(err94);
					}
				}
				{ struct _rv22 _trv; _trv = declarator(  declType, CPPConst::ccCDECL  );

				declName = _trv.declName; argNameList = _trv.argNameList; declScope = _trv.declScope; argScope = _trv.argScope; declType = _trv.outputType; usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
				{
					;  
					int _success = 0;
					if ((LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_LPAREN || LA(1)==TOK_SEMICOLON) ) {
						{
							int _success = 0;
							if ((LA(1)==TOK_ASSIGNEQUAL) ) {
								_match(TOK_ASSIGNEQUAL);
																consume();
								  initExpr   = initializer();

								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_LPAREN) ) {
								_match(TOK_LPAREN);
																consume();
								  initExpr   = expression_list();

								_match(TOK_RPAREN);
																consume();
								_success = 1;
							}
						}
						_match(TOK_SEMICOLON);
												consume();
						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_LCURLY) ) {
						{
							int _success = 0;
							if ((LA(1)==TOK_LCURLY)&&(!(((LA(1)==TOK_LCURLY)))||(memberDecl)) ) {
								if (!(!(((LA(1)==TOK_LCURLY)))||(memberDecl))) {fail_predicate("  memberDecl");}
								generic_block();
								_success = 1;
							}
							if ( !_success &&(LA(1)==TOK_LCURLY) ) {
								
								// Set up the scope for the function body
								ScopePopper functionScopePopper(this);
								if (declScope != GetCurrentScope())
								{
									EnterScopeContext(declScope, false);
								}
								EnterScope(argScope, false);
								statement_compound();
								_success = 1;
							}
							if (!_success) {
								fail_syntax(err95);
							}
						}
						_success = 1;
					}
					if (!_success) {
						fail_syntax(err96);
					}
				}
				_success = 1;
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err97);
		}
	}
	
	// If there was a scope override, then use the overridden
	// scope as the declaration scope, otherwise use the
	// pre-template scope.
	CPPScopeRefI declContextScope;
	if (templateParameterScope != declScope)
	{
		declContextScope = declScope; 
	} else {
		declContextScope =  preTemplateScope;
	}
	
      // Declare the object template.  Note that the declaration scope
	// is always well-defined -- there is no searching the scope stack
	// for declarations in containing scopes.
	
      CPPTypeRefI templateType;
	CPPDeclRefI templateDecl;
	JLStr templateName;
	
      if (usedInnerTemplateParms)
	{
		// untemplated member of class-template declaration
		// TODO: assign template token list
		templateDecl = DeclareObjectOrTypedef(
		declName,
		declType,
		sc,
		dm,
		initExpr,
		declContextScope,
		argNameList
		);
	} else {
		// template function declaration.  DeclareFunctionTemplate will check that
		// the declarator is a function
		if (DeclareFunctionTemplate(
		declName,
		declType,
		sc,
		dm,
		initExpr,
		declContextScope,
		argNameList,
		templateParameters,
		errTok,
		templateType,
		templateDecl, 
		templateName
		)
		)
		{
			SetTokensInTemplateDeclaration(
			templateType, 
			templateParameters, 
			tokenCollector.Get()
			);
		}
	}
	_success = 1;
	return;
}

  TemplateParameterListRefI   
CPPParser::template_head(void)
{
	  TemplateParameterListRefI   	 _retv;
	zzRULE;
	
	// Rollback scope stack in case of syntax error...
	ScopePopper scopePopper(this);
	EnterLocalScope();
	Tracer tracer(this, "template_head");
	int _success = 0;
	;  
	_match(TOK_TEMPLATE);
		consume();
	_match(TOK_LESSTHAN);
		consume();
	  _retv   = template_parameter_list();

	_match(TOK_GREATERTHAN);
	
	scopePopper.Commit();  
	consume();
	_success = 1;
	return _retv;
}

  TemplateParameterRefI   
CPPParser::template_parameter(  short parameterIdx  )
{
	  TemplateParameterRefI   	 _retv;
	zzRULE;
	ANTLRTokenPtr id=NULL;
	
	ANTLRTokenPtr tok = LT(1);
	JLStr argName;
	Tracer tracer(this, "template_parameter");
	int _success = 0;
	;   
	{
		int _success = 0;
		if ((LA(1)==TOK_CLASS || LA(1)==TOK_TYPENAME)&&(!(((LA(1)==TOK_CLASS || LA(1)==TOK_TYPENAME)))||(1)) ) {
			if (!(!(((
			LA(1)==TOK_CLASS || LA(1)==TOK_TYPENAME)))||(1))) {fail_predicate("  1");}
			{
				int _success = 0;
				{
					int _success = 0;
					if ((LA(1)==TOK_CLASS) ) {
						_match(TOK_CLASS);
												consume();
						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_TYPENAME) ) {
						_match(TOK_TYPENAME);
												consume();
						_success = 1;
					}
					if (!_success) {
						fail_syntax(err98);
					}
				}
				{
					int _success = 0;
					if ((LA(1)==TOK_ID) ) {
						_match(TOK_ID);
						
						id = (ANTLRTokenPtr)LT(1);

						argName =  id->getText();   
						consume();
						_success = 1;
					}
				}
				TokenCollector tokenCollector(this);   
				{
					int _success = 0;
					if ((LA(1)==TOK_ASSIGNEQUAL) ) {
						_match(TOK_ASSIGNEQUAL);
						
						
						CPPTypeRefI typeIgnored;
						tokenCollector.Clear(); 
						consume();
						  typeIgnored   = type_name();

						_success = 1;
					}
				}
				
				// Declare the type parameter as CPPTypeTemplatePlaceholder in 
				// the template scope, and create a scope associated with the 
				// template parameter.
				// This allows the template body to be parsed using the 
				// template parameter name.
				DeclareTemplateTypeParameter(
				argName,
				tokenCollector.Get(),
				tok,
				parameterIdx,
				GetTemplateLevel(),
				_retv
				);
				_success = 1;
			}
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
			{
				
				CPPTypeRefI argType; 
				CPPConst::StorageClass sc; 
				CPPConst::DeclModifier dm;
				CPPExprRefI dummyExpr;
				int _success = 0;
				{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  CPPConst::scNONE, CPPConst::dmNONE  );

				argType = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
				
				// Disallow storage class of decl modifier
				if (sc != CPPConst::scNONE || dm != CPPConst::dmNONE)
				{
					ReportError("Storage class or declaration modifier not allowed for template argument", tok);
				}
				{ struct _rv27 _trv; _trv = declarator_opt_abstract(  argType  );

				argName = _trv.declName; argType   = _trv.outputType; }
				TokenCollector tokenCollector(this);   
				{
					int _success = 0;
					if ((LA(1)==TOK_ASSIGNEQUAL) ) {
						_match(TOK_ASSIGNEQUAL);
						
						tokenCollector.Clear();   
						consume();
						  dummyExpr   = expr_shift();

						_success = 1;
					}
				}
				
				// Declare the value parameter as CPPExprTemplatePlaceholder 
				// in the template scope.
				// This allows the template body to be parsed using the 
				// template parameter name.
				DeclareTemplateValueParameter(
				argName,
				tokenCollector.Get(),
				tok,
				parameterIdx,
				GetTemplateLevel(),
				argType,
				_retv
				);
				_success = 1;
			}
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err99);
		}
	}
	_success = 1;
	return _retv;
}

  TemplateParameterListRefI   
CPPParser::template_parameter_list(void)
{
	  TemplateParameterListRefI   	 _retv;
	zzRULE;
	
	TemplateParameterRefI parmRef;
	_retv = MakeTemplateParameterList(); 
	short parameterIdx = 0;
	Tracer tracer(this, "template_parameter_list");
	int _success = 0;
	;  
	{
		int _success = 0;
		if ((LA(1)==TOK_SCOPE || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_FLOAT || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_STRUCT || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
		LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_ID) ) {
			  parmRef   = template_parameter(  parameterIdx  );

			
			AddTemplateParameterToList(_retv, parmRef);
			parameterIdx++;
			{
				while ( 1 ) {
					if ( !((
					LA(1)==TOK_COMMA)))
						break;
					int _success = 0;
					_match(TOK_COMMA);
										consume();
					  parmRef   = template_parameter(  parameterIdx  );

					
					AddTemplateParameterToList(_retv, parmRef);
					parameterIdx++;
					_success = 1;
					if ( !_success ) break; /* implied exit branch */
				}
			}
			_success = 1;
		}
	}
	_success = 1;
	return _retv;
}

CPPParser::_rv102
CPPParser::template_specialization(  const JLStr& name, CPPScopeState scopeState, const ANTLRTokenPtr& errTok   )
{
	struct _rv102 _retv;
	zzRULE;
	TemplateArgumentListRefI argList;   
	Tracer tracer(this, "template_specialization");
	int _success = 0;
	;  
	
	ScopeSaver scopeSaver(this, scopeState);
	RestoreScope(scopeState);
	_match(TOK_LESSTHAN);
		consume();
	{ struct _rv95 _trv; _trv = template_argument_list();

	argList = _trv.argList; _retv.usedInnerTemplateParms   = _trv.usedInnerTemplateParms; }
	_match(TOK_GREATERTHAN);
	
	
	scopeSaver.Restore();
	scopeSaver.Commit();
	LookupSpecialization(
	name,
	argList, 
	errTok,
	_retv.specializationName, 
	_retv.specializationType
	);
	consume();
	_success = 1;
	return _retv;
}

void
CPPParser::template_specialization_reparse(void)
{
	zzRULE;
	ANTLRTokenPtr errTok = LT(1);   
	Tracer tracer(this, "template_specialization_reparse");
	// try block for exception handling
	try {
		int _success = 0;
		;  
		declaration_external_or_member(  false  );
		_success = 1;
	} catch(AParserEX& ex) {
		// catch phrase for exception handling
		if (guessing) {
			// Propagate the exception
			throw;
		} else {
			
			ReportExceptionError(ex);
			ReportError("Error parsing template specialization", errTok);
		}
	}
	return;
}

void
CPPParser::translation_unit(void)
{
	zzRULE;
	;  
	Tracer tracer(this, "translation_unit");
	int _success = 0;
	;  
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
			LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
			LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
			LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
			LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
			LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
			LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
			LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
			LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
			LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
			LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
			LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
			LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
			LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
			LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER)))
				break;
			// try block for exception handling
			try {
				int _success = 0;
				{
					int _success = 0;
					if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_LPAREN || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || 
					LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_CHAR || 
					LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_DOUBLE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
					LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FRIEND || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
					LA(1)==TOK_LONG || LA(1)==TOK_OPERATOR || LA(1)==TOK_REGISTER || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
					LA(1)==TOK_STATIC || LA(1)==TOK_STRUCT || LA(1)==TOK_TEMPLATE || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPENAME || 
					LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || 
					LA(1)==TOK_WCHAR_T || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
					LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
					LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID || LA(1)==TOK_PNDPRAGMA) ) {
						declaration_external();
						_success = 1;
					}
					if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
					LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
					LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
					LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
					LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
					LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
					LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
					LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
					LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
					LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
					LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
					LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
					LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
					LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
					LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
					LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
					LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
					LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
					LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
					LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
					LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
					LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
					LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
					LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
					LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
					LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
					LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
					LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
					LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
					LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
					LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
					LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
					LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
					LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER) ) {
						_setmatch(err100);
						
						fail_syntax(TOK_SEMICOLON);   
						consume();
						_success = 1;
					}
					if (!_success) {
						fail_syntax(err101);
					}
				}
				_success = 1;
				if ( !_success ) break; /* implied exit branch */
			} catch(AParserEX& ex) {
				// catch phrase for exception handling
				if (guessing) {
					// Propagate the exception
					throw;
				} else {
					
					ReportExceptionError(ex);
					consume();
					consumeUntil(EXTERNAL_SYNC_TOKCLASS_set);
					if (set_el(LA(1), EXTERNAL_SYNC2_TOKCLASS_set))
					{
						consume();
					}
				}
			}
		}
	}
	_match(TOK_Eof);
		consume();
	_success = 1;
	return;
}

  CPPTypeRefI   
CPPParser::type_name(void)
{
	  CPPTypeRefI   	 _retv;
	zzRULE;
	
	CPPConst::StorageClass sc;
	CPPConst::DeclModifier dm;
	JLStr declName;
	ANTLRTokenPtr tok;
	Tracer tracer(this, "type_name");
	int _success = 0;
	;  
	{ struct _rv21 _trv; _trv = declaration_specifiers_simple(  CPPConst::scNONE, CPPConst::dmNONE  );

	_retv = _trv.type; sc = _trv.scout; dm   = _trv.dmout; }
	tok = LT(1);   
	{ struct _rv27 _trv; _trv = declarator_opt_abstract(  _retv  );

	declName = _trv.declName; _retv   = _trv.outputType; }
	
	// validate that there is no declarator name
	if (!declName.empty())
	{
		ReportError("No declarator name is allowed in a type name", tok);
	}
	_success = 1;
	return _retv;
}
